var OTABO_GW_URL = null;
var OTABO_IMG_DIR = null;
var OTABO_LANG = null;
var OTABO_PARAMS = {};
var OTABO_RESULT_DETAILS =
[
	{ id : 'InteriorDimensions', values : ['WeightLimit', 'Volume', 'Height', 'Width', 'Length', 'WheelArcWidth'] },
	{ id : 'ExteriorDimensions', values : ['Wheelbase', 'Height', 'Width', 'Length'] },
	{ id : 'VehicleDetails', values : ['EngineSize', 'FuelType', 'EmissionClass', 'Pax', 'LiftingPlatform', 'Doors', 'Radio', 'Air', 'TankSize'] },
	{ id : 'ChmEquipment', values : ['Gps', 'Mainsail', 'Teak', 'BowThruster'] },
	{ id : 'ChmCharacteristics', values : ['LengthOverall', 'Year', 'Type', 'Engine', 'TankSize', 'WaterTankSize'] },
	{ id : 'Description', values : ['Text'] }
];

var OTABO_BOOKING_URL = null;
var OTABO_BOOKING_COVERAGES_URL = null;
var OTABO_BOOKING_OPTIONALS_URL = null;
var OTABO_CONFIRM_URL = null;
var OTABO_FORM_URL = null;
var OTABO_PAYMENT = false;
var OTABO_RESULTS_URL = null;

var OTABO_OID_QTY = null;
var OTABO_OID_SEP = null;

var OTABO_TERMS_URL = null;

function otaboFormatCurrency(value, forServer)
{
	if (value != null && ('' + value).length > 0)
	{
		value = Math.round(('' + value).replace(',', '.') * 100);
		var euros = value >= 0 ? Math.floor(value / 100) : Math.ceil(value / 100);
		var cents = '' + Math.abs(value % 100);
		while (cents.length < 2)
		{
			cents = '0' + cents;
		}

		value = (value < 0 ? (forServer ? '-' : '- ') : '') + (forServer ? '' : '€ ')
				+ Math.abs(euros) + (forServer ? '.' : ',') + cents;
	}
	else
	{
		value = '';
	}

	return value;
}

function otaboFormatDate(value, forServer, type)
{
	if (value != null && Object.prototype.toString.call(value) != '[object Date]')
	{
		if (forServer)
		{
			value = value.substring(6, 10) + '-' + value.substring(3, 5) + '-' + value.substring(0, 2) + value.substring(10);
			if (value.length == 10)
			{
				value += ' 00:00:00';
			}

			var date = new Date(value.replace(' ', 'T'));
			var offset = date.getTimezoneOffset() / -60.0;
			var hours = Math.floor(offset);
			var minutes = (offset - hours) * 60;

			value += (hours < 0 ? '-' : '+') + (Math.abs(hours) < 10 ? '0' : '') + Math.abs(hours) + ':'
					+ (minutes < 10 ? '0' : '') + minutes;
		}
		else
		{
			value += '+00:00';
		}
	}

	var date = value == null || Object.prototype.toString.call(value) == '[object Date]' ? value : new Date(value.replace(' ', 'T'));
	if (date != null && date != undefined && Object.prototype.toString.call(date) == '[object Date]'
			&& !isNaN(date.getTime()))
	{
		var year = forServer ? date.getUTCFullYear() : date.getFullYear();
		var month = forServer ? date.getUTCMonth() + 1 : date.getMonth() + 1;
		var day = forServer ? date.getUTCDate() : date.getDate();
		var hours = forServer ? date.getUTCHours() : date.getHours();
		var min = forServer ? date.getUTCMinutes() : date.getMinutes();
		var sec = forServer ? date.getUTCSeconds() : date.getSeconds();

		month = (month < 10 ? '0' : '') + month;
		day = (day < 10 ? '0' : '') + day;
		hours = (hours < 10 ? '0' : '') + hours;
		min = (min < 10 ? '0' : '') + min;
		sec = (sec < 10 ? '0' : '') + sec;

		if (forServer)
		{
			value = year + '-' + month + '-' + day + ' ' + hours + ':' + min + ':' + sec;
		}
		else
		{
			value = type == undefined || type == 'date' || type == 'datetime' ? day + '-' + month + '-' + year : '';
			value += (type == undefined || type == 'time' || type == 'datetime') ? (value == '' ? '' : ' ') + hours + ':' + min : '';
		}
	}
	else
	{
		value = '';
	}
	
	return value;
}

function otaboRequest(postParams, callback, progressCallback, method)
{
	var url = OTABO_GW_URL;

	var xmlhttp = null;
	if (window.XMLHttpRequest)
	{
		xmlhttp = new XMLHttpRequest();
	}
	else
	{
		xmlhttp = new ActiveXObject('Microsoft.XMLHTTP');
	}

	// Callback function.
	if (progressCallback)
	{
		xmlhttp.onprogress = progressCallback;

		if (xmlhttp.upload)
		{
			xmlhttp.upload.onprogress = progressCallback;
			xmlhttp.upload.addEventListener('progress', progressCallback);
		}
	}

	xmlhttp.onreadystatechange = function()
	{
		if (xmlhttp.readyState == 4)
		{
			if (xmlhttp.status == 200)
			{
				var json = null;

				try
				{
					json = JSON.parse(xmlhttp.responseText);
				}
				catch (e)
				{
					json = null;
					callback(false, xmlhttp.responseText);
				}

				if (json != null)
				{
					callback(json && json.success, json, xmlhttp);
				}
			}
			else
			{
				var json = null;
				try
				{
					json = JSON.parse(xmlhttp.responseText);
				}
				catch (e)
				{
					json = null;
					callback(false, xmlhttp.responseText);
				}
				
				callback(false, json ? json : xmlhttp.responseText, xmlhttp);
			}
		}
	};

	// Get the parameters.
	var getp = '?action=oaj&otabo_lang=' + OTABO_LANG;
	var postp = '';
	for (var i = 0; i < postParams.length - 1; i++)
	{
		if (postParams[i + 1] != null)
		{
			var key = encodeURIComponent(postParams[i++]);
			var val = encodeURIComponent(postParams[i]);

			postp += (postp == '' ? '' : '&') + key + '=' + val;
		}
		else
		{
			i++;
		}
	}

	// Some last parameter left over? This can be a parameter string.
	if (postParams.length % 2 == 1)
	{
		postp += (postp === '' ? '' : '&') + postParams[postParams.length - 1];
	}

	xmlhttp.open(method ? method : 'POST', url + getp, true);
	if (postParams)
	{
		xmlhttp.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
	}

	xmlhttp.send(postp);
}

function otaboSleep(ms)
{
	return new Promise(resolve => setTimeout(resolve, ms));
}

function otaboLoadBookingCoverages(quote)
{
	var e = document.getElementById('otabo_coverage_modify');
	if (e)
	{
		e.style.display = 'none';
	}
	
	var div = document.getElementById('otabo_coverages');
	var ul = document.createElement('ul');
	div.appendChild(ul);
	
	for (var i in quote.coverages)
	{
		var coverage = quote.coverages[i];
		var li = document.createElement('li');
		ul.appendChild(li);

		var h1 = document.createElement('h1');
		h1.innerHTML = coverage.name;
		li.appendChild(h1);
		
		if (coverage.desc && coverage.desc.length > 0)
		{
			var p = document.createElement('p');
			p.innerHTML = coverage.desc;
			li.appendChild(p);
		}		
		
		var table = document.createElement('table');
		li.appendChild(table);
		
		var tr = document.createElement('tr');
		table.appendChild(tr);
		
		var td = document.createElement('td');
		td.innerHTML = _S.booking_coverage_deposit;
		tr.appendChild(td);
		
		var td = document.createElement('td');
		td.innerHTML = otaboFormatCurrency(coverage.deposit ? coverage.deposit : 0);
		tr.appendChild(td);

		if (coverage.excess_info && coverage.excess_info.length > 0)
		{
			var tr = document.createElement('tr');
			table.appendChild(tr);

			var td = document.createElement('td');
			td.innerHTML = _S.booking_coverage_excess;
			tr.appendChild(td);
			
			var td = document.createElement('td');
			td.innerHTML = coverage.excess_info.replace('\n', '<br />');
			tr.appendChild(td);

			var href = null;
			if (quote.vendor && quote.vendor.terms_url)
			{
				href = quote.vendor.terms_url;
			}
			else if (OTABO_TERMS_URL)
			{
				href = OTABO_TERMS_URL;
			}
			
			if (href)
			{
				var a = document.createElement('a');
				a.className = 'hint';
				a.target = '_blank';
				a.href = href;
				a.innerHTML = _S.booking_coverage_view_terms;
				td.appendChild(a);
			}
		}
		else if (coverage.excess_damage || coverage.excess_theft)
		{
			if (coverage.excess_damage)
			{		
				var tr = document.createElement('tr');
				table.appendChild(tr);

				var td = document.createElement('td');
				td.innerHTML = _S.booking_coverage_excess_damage;
				tr.appendChild(td);

				var td = document.createElement('td');
				td.innerHTML = otaboFormatCurrency(coverage.excess_damage);
				tr.appendChild(td);
			}
			
			if (coverage.excess_theft)
			{		
				var tr = document.createElement('tr');
				table.appendChild(tr);

				var td = document.createElement('td');
				td.innerHTML = _S.booking_coverage_excess_theft;
				tr.appendChild(td);

				var td = document.createElement('td');
				td.innerHTML = otaboFormatCurrency(coverage.excess_theft);
				tr.appendChild(td);
			}
		}
		else
		{
			var tr = document.createElement('tr');
			table.appendChild(tr);

			var td = document.createElement('td');
			td.innerHTML = _S.booking_coverage_excess;
			tr.appendChild(td);

			var td = document.createElement('td');
			td.innerHTML = otaboFormatCurrency(coverage.excess ? coverage.excess : 0);
			tr.appendChild(td);
		}

		var div = document.createElement('div');
		div.className = 'rate';
		li.appendChild(div);

		var span = document.createElement('span');
		span.innerHTML = coverage.rate > 0 ? _S.results_rate : '';
		div.appendChild(span);

		var span = document.createElement('span');
		span.innerHTML = coverage.rate > 0 ? otaboFormatCurrency(coverage.rate) : _S.results_rate_included;
		div.appendChild(span);
	
		var a = document.createElement('a');
		if (quote.optionals && quote.optionals.length > 0)
		{
			a.href = OTABO_BOOKING_OPTIONALS_URL;
		}
		else
		{
			a.href = OTABO_BOOKING_URL;
		}
		
		a.href += '&cid=' + i;
	
		var button = document.createElement('button');
		button.innerHTML = _S.results_select;
		a.appendChild(button);
	
		div.appendChild(a);
	}
}

function otaboLoadBooking(reservation, osd, rid, mpi, error, countries)
{
	var details = { };
	var form = document.getElementById('otabo_booking_form');
	var inputs = form.getElementsByTagName('input');
	for (var i = 0; i < inputs.length; i++)
	{
		inputs[i].disabled = true;
	}
	
	var terms = document.getElementById('otabo_terms');
	if (terms)
	{
		terms.disabled = true;
	}
	
	var privacy = document.getElementById('otabo_privacy');
	if (privacy)
	{
		privacy.disabled = true;
	}
		
	var countryInput = document.getElementById('otabo_country');
	var invoicingCountryInput = document.getElementById('otabo_invoicing_country');
	var invoicingTypeInput = document.getElementById('otabo_invoicing_type');
	
	var terms = document.getElementById('otabo_terms');
	terms.checked = true;
	var privacy = document.getElementById('otabo_privacy');
	privacy.checked = true;

	document.getElementById('otabo_error_msg').innerHTML = '';	
	document.getElementById('otabo_error').style.display = 'none';
	document.getElementById('otabo_submit').style.display = 'none';
	document.getElementById('otabo_loading').style.display = 'block';

	var response = reservation;
	if (response)
	{
		// Fill the form.
		if (response.reservation && response.reservation.client)
		{
			for (var i = 0; i < inputs.length; i++)
			{
				if (inputs[i].type != 'text' || inputs[i].id == 'otabo_country')
				{
					continue;
				}
	
				var id = inputs[i].id.substring(6);
				inputs[i].value = response.reservation.client[id] ? response.reservation.client[id] : null;
			}
		
			if (response.reservation.client.country)
			{
				for (var i = 0; i < countries.length; i++)
				{
					if (countries[i].code == response.reservation.client.country)
					{
						countryInput.value = countries[i].name;
						break;
					}
				}
			}
		
			if (response.reservation.client.invoicing_country && invoicingCountryInput)
			{
				for (var i = 0; i < countries.length; i++)
				{
					if (countries[i].code == response.reservation.client.invoicing_country)
					{
						invoicingCountryInput.value = countries[i].name;
						break;
					}
				}
			}
		
			if (response.reservation.client.invoicing_type && invoicingTypeInput)
			{
				var types = [ { code : 'private', name : _S['details_invoicing_type_private'] },
						{ code : 'business', name : _S['details_invoicing_type_business'] },
						{ code : 'one_man_business', name : _S['details_invoicing_type_one_man_business'] },
						{ code : 'public_amm', name : _S['details_invoicing_type_public_amm'] } ];
				for (var i = 0; i < types.length; i++)
				{
					if (types[i].code == response.reservation.client.invoicing_type)
					{
						invoicingTypeInput.value = types[i].name;
						break;
					}
				}
				
				document.getElementById('otabo_invoicing_company').parentNode.style.display = response.reservation.client.invoicing_type == 'private' ? 'none' : 'block';
				document.getElementById('otabo_invoicing_name').parentNode.style.display = response.reservation.client.invoicing_type != 'private' ? 'none' : 'block';
				document.getElementById('otabo_invoicing_surname').parentNode.style.display = response.reservation.client.invoicing_type != 'private' ? 'none' : 'block';
				document.getElementById('otabo_invoicing_tax_number').parentNode.className = response.reservation.client.invoicing_type == 'private' ? 'w100' : '';
				document.getElementById('otabo_invoicing_type').parentNode.parentNode.className = response.reservation.client.invoicing_type == 'private' ? 'w100' : '';
				document.getElementById('otabo_invoicing_vat_number').parentNode.style.display = response.reservation.client.invoicing_type == 'private' ? 'none' : 'block';
			}

			document.getElementById('otabo_booking_form').style.display = 'flex';
		}
		else
		{
			var form = document.getElementById('otabo_booking_form');
			form.style.display = 'none';
			if (terms)
			{
				terms.parentNode.style.display = 'none';
			}

			if (privacy)
			{
				privacy.parentNode.style.display = 'none';
			}
			
			var h1 = document.createElement('h1');
			h1.innerHTML = _S.booking_reservation_title.replace('{ref_id}', response.reservation.ref_id);

			form.parentNode.insertBefore(h1, form);
		}

		// Do we still have to confirm the reservation?
		if (response.reservation.status == 'Initiate' && response.payment && response.payment.status == 'confirmed')
		{
			otaboRequest(['cmd', 'confirm', 'reservation', JSON.stringify(response.reservation), 'payment', JSON.stringify(response.payment)], function(success, response2)
			{
				document.getElementById('otabo_loading').style.display = 'block';
				if (success && response2)
				{
					if (OTABO_CONFIRM_URL.indexOf('osd=') != -1)
					{
						document.getElementById('otabo_loading').style.display = 'none';
						window.location = OTABO_CONFIRM_URL;
					}
					else
					{
						document.getElementById('otabo_loading').style.display = 'none';
						document.getElementById('otabo_confirmed').style.display = 'block';
						document.getElementById('otabo_confirmed_msg').innerHTML = _S.booking_confirmed.replace('{ref_id}', response.reservation.ref_id);
					}
				}
				else
				{
					document.getElementById('otabo_loading').style.display = 'none';
					document.getElementById('otabo_submit').style.display = 'inline-block';
					document.getElementById('otabo_error_msg').innerHTML = response2 && response2.error ? response2.error : response2;
					document.getElementById('otabo_error').style.display = 'block';												
				}
			});
		}
		else if (response.reservation.status == 'Initiate' && (!response.payment || response.payment.status != 'confirmed')
				&& OTABO_PAYMENT)
		{
			document.getElementById('otabo_loading').style.display = 'none';
			document.getElementById('otabo_submit').innerHTML = _S.booking_pay.replace('{totals}', otaboFormatCurrency(response.reservation.totals_to_pay ? response.reservation.totals_to_pay : response.reservation.totals));
			document.getElementById('otabo_submit').style.display = 'inline-block';
			document.getElementById('otabo_submit').onclick = function()
			{
				document.getElementById('otabo_loading').style.display = 'block';
				otaboRequest(['cmd', 'payment', 'osd', osd, 'reservation', JSON.stringify(response.reservation)], function(success, response)
				{
					if (success && response && response.result && response.result.url)
					{
						window.location = response.result.url.href;
					}
					else
					{
						document.getElementById('otabo_loading').style.display = 'none';
						document.getElementById('otabo_submit').style.display = 'inline-block';
						document.getElementById('otabo_error_msg').innerHTML = response && response.error ? response.error : response;
						document.getElementById('otabo_error').style.display = 'block';												
					}
				});
			}
			
			document.getElementById('otabo_cancel').style.display = 'inline-block';
			document.getElementById('otabo_cancel').onclick = function()
			{
				document.getElementById('otabo_loading').style.display = 'block';
				otaboRequest(['cmd', 'cancel', 'osd', osd, 'reservation', JSON.stringify(response.reservation), 'payment', JSON.stringify(response.payment)], function(success, response)
				{
					if (success && response)
					{
						window.location = OTABO_FORM_URL;
					}
					else
					{
						document.getElementById('otabo_loading').style.display = 'none';
						document.getElementById('otabo_submit').style.display = 'inline-block';
						document.getElementById('otabo_error_msg').innerHTML = response && response.error ? response.error : response;
						document.getElementById('otabo_error').style.display = 'block';												
					}
				});
			}
		}
		else if (response.reservation.status == 'Reserved')
		{
			if (OTABO_CONFIRM_URL.indexOf('osd=') != -1)
			{
				document.getElementById('otabo_loading').style.display = 'none';
				window.location = OTABO_CONFIRM_URL;
			}
			else
			{
				document.getElementById('otabo_loading').style.display = 'none';
				document.getElementById('otabo_confirmed').style.display = 'block';
				document.getElementById('otabo_confirmed_msg').innerHTML = _S.booking_confirmed.replace('{ref_id}', response.reservation.ref_id);
			}
		}
		else if (response.reservation.status == 'Cancelled')
		{
			document.getElementById('otabo_loading').style.display = 'none';
			document.getElementById('otabo_error').style.display = 'block';
			document.getElementById('otabo_error_msg').innerHTML = _S.booking_canceled.replace('{ref_id}', response.reservation.ref_id);
		}

		// If there was something wrong with the payment, they may retry.
		if (error)
		{
			document.getElementById('otabo_loading').style.display = 'none';
			document.getElementById('otabo_error_msg').innerHTML += document.getElementById('otabo_error_msg').innerHTML != '' ? '<br />' + error : error;
			document.getElementById('otabo_error').style.display = 'block';
		}			
	}
	else
	{
		document.getElementById('otabo_loading').style.display = 'none';
		document.getElementById('otabo_submit').style.display = 'inline-block';
		document.getElementById('otabo_error_msg').innerHTML = response && response.error ? response.error : response;
		document.getElementById('otabo_error').style.display = 'block';				
	}
}

function otaboLoadBookingDetails(osd, quote, cid, oid, countries, requiredFields)
{
	var details = { };

	var form = document.getElementById('otabo_booking_form');
	var inputs = form.getElementsByTagName('input');
	var selectFields = [];
	
	for (var i = 0; i < inputs.length; i++)
	{
		if (inputs[i].id == 'otabo_country' || inputs[i].id == 'otabo_invoicing_country'
				|| inputs[i].id == 'otabo_invoicing_type')
		{
			selectFields.push(inputs[i].id.substr(6));
		}
		
		if (inputs[i].type != 'text' || inputs[i].id == 'otabo_country'
				|| inputs[i].id == 'otabo_invoicing_country'
				|| inputs[i].id == 'otabo_invoicing_type')
		{
			continue;
		}
		
		inputs[i].onfocus = function()
		{
			this.classList.remove('error');
			if (this.id == 'otabo_invoicing_pec')
			{
				document.getElementById('otabo_invoicing_sdi_code').classList.remove('error');
			}
			else if (this.id == 'otabo_invoicing_sdi_code')
			{
				document.getElementById('otabo_invoicing_pec').classList.remove('error');
			}
			else if (this.id == 'otabo_invoicing_tax_number')
			{
				document.getElementById('otabo_invoicing_vat_number').classList.remove('error');
			}
			else if (this.id == 'otabo_invoicing_vat_number')
			{
				document.getElementById('otabo_invoicing_tax_number').classList.remove('error');
			}
		}
		
		if (details[inputs[i].id.substring(6)])
		{
			inputs[i].value = details[inputs[i].id.substring(6)];
		}
	}
	
	var showInvoicingFields = () =>
	{
		if (document.getElementById('otabo_invoicing_company'))
		{
			document.getElementById('otabo_invoicing_company').parentNode.style.display = details.invoicing_type == 'private' ? 'none' : 'block';
			document.getElementById('otabo_invoicing_name').parentNode.style.display = details.invoicing_type != 'private' ? 'none' : 'block';
			document.getElementById('otabo_invoicing_surname').parentNode.style.display = details.invoicing_type != 'private' ? 'none' : 'block';
			document.getElementById('otabo_invoicing_tax_number').parentNode.className = details.invoicing_type == 'private' ? 'w100' : '';
			document.getElementById('otabo_invoicing_type').parentNode.parentNode.className = details.invoicing_type == 'private' ? 'w100' : '';
			document.getElementById('otabo_invoicing_vat_number').parentNode.style.display = details.invoicing_type == 'private' ? 'none' : 'block';
		}
	};
		
	for (var i in selectFields)
	{
		var field = selectFields[i];
		var records = field == 'invoicing_type' ? 
				[ { code : 'private', name : _S['details_invoicing_type_private'] },
					{ code : 'business', name : _S['details_invoicing_type_business'] },
					{ code : 'one_man_business', name : _S['details_invoicing_type_one_man_business'] },
					{ code : 'public_amm', name : _S['details_invoicing_type_public_amm'] } ] :
				countries;
			
		var selectInput = document.getElementById('otabo_' + field);
		selectInput.click = false;
		
		var selectList = document.getElementById('otabo_' + field + '_list');
		for (var i = 0; i < records.length; i++)
		{
			var li = document.createElement('li');
			selectList.appendChild(li);
			li.innerHTML = records[i].name;
			li.code = function(record)
			{
				return function()
				{
					return record.code;
				}
			
			}(records[i]);
		
			li.onmousedown = function(field, record, selectInput)
			{
				return function()
				{
					selectInput.click = true;
					details[field] = record.code;

					selectInput.classList.remove('error');
					selectInput.value = record.name;
				}
			}(field, records[i], selectInput);

			if (details[field] && records[i].code == details[field])
			{
				selectInput.value = li.innerHTML;
			}
		}
	
		selectInput.onfocus = function(field, selectInput, selectList)
		{
			return () =>
			{
				selectInput.parentNode.classList.remove('error');
				selectList.style.display = 'block';
			}
		}(field, selectInput, selectList);

		selectInput.onblur = function(field, selectInput, selectList)
		{
			return () =>
			{
				var selected = false;
				for (var i = 0; i < selectList.children.length; i++)
				{
					if (!selectInput.click && window.getComputedStyle(selectList.children[i], null).display != 'none')
					{
						selected = true;
						selectInput.value = selectList.children[i].innerHTML;
						selectList.children[i].onmousedown();		
			
						break;					
					}
				}
		
				if (!selected && details[field])
				{
					for (var i = 0; i < selectList.children.length; i++)
					{
						if (selectList.children[i].code() == details[field])
						{
							selected = true;
							selectInput.value = selectList.children[i].innerHTML;
							selectList.children[i].onmousedown();		
			
							break;					
						}
					}

				}
		
				if (!selected)
				{
					selectInput.classList.add('error');
				}

				selectInput.click = false;
				selectList.style.display = 'none';
				
				showInvoicingFields();
			}
		}(field, selectInput, selectList);

		selectInput.onkeyup = function(field, selectInput, selectList)
		{
			return function(e)
			{
				var pattern = new RegExp('.*' + selectInput.value + '.*', 'i');
				for (var i = 0; i < selectList.children.length; i++)
				{
					var li = selectList.children[i];
					li.style.display = li.innerHTML && pattern.test(li.innerHTML) ? 'block' : 'none';
				}
			}
		}(field, selectInput, selectList);
	
		selectInput.onkeydown = function(field, selectInput, selectList)
		{
			return function(e)
			{
				var res = true;
				if (e.keyCode == 9)
				{
					selectInput.blur();			
					res = false;
				}
		
				return res;
			}
		}(field, selectInput, selectList);
	}
	
	showInvoicingFields();
	
	var terms = document.getElementById('otabo_terms');
	var privacy = document.getElementById('otabo_privacy');
	
	terms.onchange = function()
	{
		this.classList.remove('error');
	}
	
	privacy.onchange = function()
	{
		this.classList.remove('error');
	}
	
	document.getElementById('otabo_submit').onclick = function()
	{
		var error = false;
		var inputs = form.getElementsByTagName('input');
		for (var i = 0; i < inputs.length; i++)
		{
			if (inputs[i].type != 'text' || inputs[i].id == 'otabo_country' || inputs[i].id == 'otabo_invoicing_country' || inputs[i].id == 'otabo_invoicing_type')
			{
				continue;
			}
			
			var key = inputs[i].name.substring(6);
			details[key] = inputs[i].value;
			
			if (inputs[i].value == ''
					&& (!requiredFields || requiredFields.length == 0 || requiredFields.indexOf(inputs[i].id.substr(6)) != -1)
					&& (!inputs[i].id.substr(6).startsWith('invoicing_') || requiredFields.indexOf(inputs[i].id.substr(6)) != -1))
			{
				if ((inputs[i].id == 'otabo_tax_number' || inputs[i].id == 'otabo_province') && details.country && details.country != 'IT')
				{
					inputs[i].classList.remove('error');
					continue;
				}
				
				inputs[i].classList.add('error');

				document.getElementById('otabo_error_msg').innerHTML = _S.booking_error_fill_form;
				error = true;
			}
		}
		
		for (var i in selectFields)
		{
			var field = selectFields[i];
			if ((!details[field] || details[field] == '')
					&& (!requiredFields || requiredFields.length == 0 || requiredFields.indexOf(field) != -1)
					&& (!field.startsWith('invoicing_') || requiredFields.indexOf(field) != -1))
			{
				document.getElementById('otabo_' + field).classList.add('error');

				document.getElementById('otabo_error_msg').innerHTML = _S.booking_error_fill_form;
				error = true;
			}
		}
		
		if (details.date_of_birth && details.date_of_birth != '')
		{
			details.date_of_birth = otaboFormatDate(details.date_of_birth, true, 'datetime');
			if (!details.date_of_birth || details.date_of_birth == '')
			{
				document.getElementById('otabo_date_of_birth').classList.add('error');

				document.getElementById('otabo_error_msg').innerHTML = _S.booking_error_fill_form;
				error = true;
			}
		}
		
		// Check invoicing fields. If one is compiled, all have to be compiled.
		var gotInvoicing = false;
		for (var i in inputs)
		{
			if (inputs[i].id && inputs[i].id.startsWith('otabo_invoicing') && inputs[i].id != 'otabo_invoicing_type'
					&& inputs[i].id != 'otabo_invoicing_country'
					&& window.getComputedStyle(inputs[i].parentNode).display != 'none'
					&& inputs[i].value != '')
			{
				gotInvoicing = true;
				break;
			}
		}
		
		if (gotInvoicing)
		{
			for (var i in inputs)
			{
				if (!inputs[i] || !inputs[i].id)
				{
					continue;
				}
				
				if (inputs[i].id && inputs[i].id.startsWith('otabo_invoicing')
						&& window.getComputedStyle(inputs[i].parentNode).display != 'none'
						&& inputs[i].value == '')
				{
					if (inputs[i].id == 'otabo_invoicing_tax_number' && (details.invoicing_vat_number && details.invoicing_vat_number != '' || !details.invoicing_country || details.invoicing_country != 'IT')
							|| inputs[i].id == 'otabo_invoicing_vat_number' && (details.invoicing_tax_number && details.invoicing_tax_number != '' || !details.invoicing_country || details.invoicing_country != 'IT')
							|| inputs[i].id == 'otabo_invoicing_pec' && (details.invoicing_sdi_code && details.invoicing_sdi_code != '' || !details.invoicing_country || details.invoicing_country != 'IT')
							|| inputs[i].id == 'otabo_invoicing_sdi_code' && (details.invoicing_pec && details.invoicing_pec != '' || !details.invoicing_country || details.invoicing_country != 'IT')
							|| inputs[i].id == 'otabo_invoicing_province' && (!details.invoicing_country || details.invoicing_country != 'IT')
							|| details.invoicing_type == 'private' && (inputs[i].id == 'otabo_invoicing_pec' || inputs[i].id == 'otabo_invoicing_sdi_code'))
					{
						continue;
					}
					
					inputs[i].classList.add('error');

					document.getElementById('otabo_error_msg').innerHTML = _S.booking_error_fill_form;
					error = true;
				}
			}
		}
		
		var email = document.getElementById('otabo_email');
		var emailConf = document.getElementById('otabo_email_confirm');
		
		const re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
		if (!error && !re.test(email.value.toLowerCase()))
		{
			email.classList.add('error');
			
			error = true;
			document.getElementById('otabo_error_msg').innerHTML = _S.booking_error_email_not_valid;
		}
		else if (emailConf && email.value != emailConf.value)
		{
			email.classList.add('error');
			emailConf.classList.add('error');

			error = true;
			document.getElementById('otabo_error_msg').innerHTML = _S.booking_error_emails_not_equal;
		}
		
		if (!error && details.invoicing_pec && details.invoicing_pec != '' && !re.test(details.invoicing_pec.toLowerCase()))
		{
			document.getElementById('otabo_invoicing_pec').classList.add('error');
			
			error = true;
			document.getElementById('otabo_error_msg').innerHTML = _S.booking_error_email_not_valid;
		}
		
		if (!error && (!terms.checked || !privacy.checked))
		{
			if (!terms.checked)
			{
				terms.classList.add('error');
			}
			
			if (!privacy.checked)
			{
				privacy.classList.add('error');
			}
			
			error = true;
			document.getElementById('otabo_error_msg').innerHTML = _S.booking_error_terms;
		}
		
		if (error)
		{
			document.getElementById('otabo_error').style.display = 'block';
		}
		else
		{
			document.getElementById('otabo_error').style.display = 'none';
			document.getElementById('otabo_submit').style.display = 'none';
			document.getElementById('otabo_loading').style.display = 'block';
			
			var thisQuote = JSON.parse(JSON.stringify(quote));
			thisQuote.client = details;

			if (cid)
			{
				thisQuote.coverage = thisQuote.coverages[cid];
			}
			
			delete thisQuote.coverages;
			
			var optionals = [];
			for (var i in thisQuote.optionals)
			{
				if (thisQuote.optionals[i].required && thisQuote.optionals[i].required == true)
				{
					optionals.push(thisQuote.optionals[i]);
				}
			}
					
			if (oid && oid != '')
			{				
				var oids = oid.split(',');
				for (var i in oids)
				{
					var id = oids[i];
					
					var qty = null;
					var p = id.indexOf(OTABO_OID_SEP);
					if (p != -1)
					{
						qty = id.substr(0, p);
						id = id.substr(p + OTABO_OID_SEP.length);
						
						thisQuote.optionals[id].quantity = qty;
					}
					
					optionals.push(thisQuote.optionals[id]);
				}
			}

			thisQuote.optionals = optionals;

			otaboRequest(['cmd', 'submit', 'osd', osd, 'quote', JSON.stringify(thisQuote)], function(success, response)
			{
				if (success && response)
				{
					// Do we have to pay?
					if (OTABO_PAYMENT)
					{
						otaboRequest(['cmd', 'payment', 'osd', osd, 'reservation', JSON.stringify(response.result)], function(success, response)
						{							
							if (success && response && response.result && response.result.url)
							{
								window.location = response.result.url.href;
							}
							else
							{
								document.getElementById('otabo_loading').style.display = 'none';
								document.getElementById('otabo_submit').style.display = 'inline-block';
								document.getElementById('otabo_error_msg').innerHTML = response && response.error ? response.error : response;
								document.getElementById('otabo_error').style.display = 'block';												
							}
						});
					}
					else
					{
						document.getElementById('otabo_loading').style.display = 'none';
						window.location = OTABO_CONFIRM_URL;
					}
				}
				else
				{
					document.getElementById('otabo_loading').style.display = 'none';
					document.getElementById('otabo_submit').style.display = 'inline-block';
					document.getElementById('otabo_error_msg').innerHTML = response && response.error ? response.error : response;
					document.getElementById('otabo_error').style.display = 'block';				
				}
			});
		}
	};
}

function otaboLoadBookingOptionals(quote, cid, groups, oid)
{
	var div = document.getElementById('otabo_optionals');
	
	var e = document.getElementById('otabo_optionals_modify');
	if (e)
	{
		e.style.display = 'none';
	}

	var oidStr = '';
	var oids = oid != null && oid != '' ? oid.split(',') : [];
	
	var uls = [];
	for (var i in groups)
	{
		uls[i] = document.createElement('ul');
	}
	
	var updateTotals = () =>
	{
		var extraTotals = 0;
		for (var ii = 0; ii < quote.optionals.length; ii++)
		{
			if (quote.optionals[ii].required && quote.optionals[ii].required == true)
			{
				extraTotals += parseFloat(quote.optionals[ii].rate);
			}
		}
	
		for (var ii = 0; ii < oids.length; ii++)
		{
			var id = oids[ii];
			var qty = 1;
			
			var p = id.indexOf(OTABO_OID_SEP);
			if (p != -1)
			{
				qty = parseInt(id.substr(0, p));
				id = id.substr(p + OTABO_OID_SEP.length);
			}
			
			extraTotals += parseFloat(quote.optionals[id].rate) * qty;
		}

		var totals = parseFloat(quote.rate) + extraTotals;
		if (cid !== null)
		{
			totals += parseFloat(quote.coverages[cid].rate);
		}
	
		var e = document.getElementById('otabo_totals');
		var list = document.getElementById('otabo_optionals_list');

		oidStr = '';
		
		if (e)
		{				
			e.innerHTML = otaboFormatCurrency(totals);
	
			while (list.children.length > 1)
			{
				list.removeChild(list.children[1]);
			}

			// Check required optionals first.
			for (var ii in quote.optionals)
			{
				var optional = quote.optionals[ii];
				if (optional.required && optional.required == true)
				{
					var span = document.createElement('span');
					list.appendChild(span);
					span.className = 'optionals';
			
					var table = document.createElement('table');
					span.appendChild(table);
			
					var tr = document.createElement('tr');
					table.appendChild(tr);
			
					var td = document.createElement('td');
					tr.appendChild(td);
					td.innerHTML = optional.name;
			
					var td = document.createElement('td');
					tr.appendChild(td);
					td.className = 'rate';
					td.innerHTML = otaboFormatCurrency(optional.rate);
				}
			}
		}
					
		for (var ii = 0; ii < oids.length; ii++)
		{
			var id = oids[ii];
			var qty = null;
		
			var p = id.indexOf(OTABO_OID_SEP);
			if (p != -1)
			{
				qty = parseInt(id.substr(0, p));
				id = id.substr(p + OTABO_OID_SEP.length);
			}
			
			var optional = quote.optionals[id];
			oidStr += (oidStr == '' ? '' : ',') + oids[ii];

			if (list)
			{	
				var span = document.createElement('span');
				list.appendChild(span);
				span.className = 'optionals';
	
				var table = document.createElement('table');
				span.appendChild(table);
	
				var tr = document.createElement('tr');
				table.appendChild(tr);
	
				var td = document.createElement('td');
				tr.appendChild(td);
				td.innerHTML = (qty !== null ? qty + OTABO_OID_QTY : '') + optional.name;
	
				var td = document.createElement('td');
				tr.appendChild(td);
				td.className = 'rate';
				td.innerHTML = otaboFormatCurrency(optional.rate * (qty !== null ? qty : 1));
			}
		}

		oidStr = encodeURI(oidStr);

		if (e)
		{
			document.getElementById('otabo_totals_holder').style.display = list.children.length > 1 || cid ? 'block' : 'none';
			document.getElementById('otabo_optionals_holder').style.display = list.children.length > 1 ? 'block' : 'none';
		}
	
		document.getElementById('otabo_optionals_totals').innerHTML = otaboFormatCurrency(totals);
		nextLink.href = OTABO_BOOKING_URL + '&oid=' + oidStr;
	
		var e = document.getElementById('otabo_booking_link');
		if (e)
		{
			e.href = nextLink.href;
		}
		
		var e = document.getElementById('otabo_coverage_modify');
		if (e)
		{
			e.href = OTABO_BOOKING_COVERAGES_URL + '&oid=' + oidStr;
		}
	};
	
	var nextLink = document.createElement('a');	
	for (var i in quote.optionals)
	{
		var optional = quote.optionals[i];
		if (!optional || !optional.id)
		{
			continue;
		}

		var li = document.createElement('li');

		var h1 = document.createElement('h1');
		h1.innerHTML = optional.name;
		li.appendChild(h1);
				
		var table = document.createElement('table');
		li.appendChild(table);
		
		var tr = document.createElement('tr');
		table.appendChild(tr);
		
		var td = document.createElement('td');
		td.innerHTML = optional.desc;
		tr.appendChild(td);
		
		var td = document.createElement('td');
		td.className = 'rate';
		tr.appendChild(td);

		var span = document.createElement('span');
		span.innerHTML = optional.rate > 0 ? _S.results_rate : '';
		td.appendChild(span);

		var span = document.createElement('span');
		span.innerHTML = optional.rate > 0 ? otaboFormatCurrency(optional.rate) : _S.results_rate_included;
		td.appendChild(span);

		if (optional.required && optional.required == true)
		{
			var span = document.createElement('span');
			td.appendChild(span);
			span.className = 'hint';
			span.innerHTML = _S.results_required;
		}
		else if (!optional.countable)
		{
			var button = document.createElement('button');
			td.appendChild(button);
			button.innerHTML = _S.results_select;
			button.onclick = function(optional, i)
			{
				return function()
				{
					if (oids.indexOf(i) == -1)
					{
						oids.push(i);
						this.innerHTML = _S.results_remove;
						this.classList.add('remove');
					}
					else
					{
						oids.splice(oids.indexOf(i), 1);
						this.innerHTML = _S.results_select;
						this.classList.remove('remove');
					}
				
					updateTotals();
				}
			}(optional, i);

			if (oids.indexOf(i) == -1)
			{
				button.innerHTML = _S.results_select;
			}
			else
			{
				button.innerHTML = _S.results_remove;
				button.classList.add('remove');
			}
		}
		else
		{
			var span = document.createElement('span');
			td.appendChild(span);
			span.className = 'quantity';
			
			var button = document.createElement('button');
			span.appendChild(button);
			button.innerHTML = '−';
			
			var qty = document.createElement('span');
			span.appendChild(qty);
			
			var found = false;
			for (var ii in oids)
			{
				if (oids[ii].endsWith(OTABO_OID_SEP + i))
				{
					found = true;
					qty.innerHTML = oids[ii].substr(0, oids[ii].indexOf(OTABO_OID_SEP));
				}
			}
			
			if (!found)
			{
				qty.innerHTML = '0';
			}

			button.onclick = ((span, optional, i) =>
			{
				return () =>
				{
					var quantity = parseInt(span.textContent);
					quantity = Math.max(0, quantity - 1);
				
					var found = false;
					for (var ii in oids)
					{
						if (oids[ii].endsWith(OTABO_OID_SEP + i))
						{
							found = true;
							if (quantity > 0)
							{
								oids[ii] = quantity + OTABO_OID_SEP + i;
							}
							else
							{
								oids.splice(ii, 1);
							}
						
							break;
						}
					}
				
					if (quantity > 0 && !found)
					{
						oids.push(quantity + OTABO_OID_SEP + i);
					}
				
					span.innerHTML = quantity;
					updateTotals();
				}
				
			})(qty, optional, i);
			
			var button = document.createElement('button');
			span.appendChild(button);
			button.innerHTML = '＋';
			
			button.onclick = ((span, optional, i) =>
			{
				return () =>
				{
					var quantity = parseInt(span.textContent);
					quantity = quantity + 1;
				
					var found = false;
					for (var ii in oids)
					{
						if (oids[ii].endsWith(OTABO_OID_SEP + i))
						{
							found = true;
							if (quantity > 0)
							{
								oids[ii] = quantity + OTABO_OID_SEP + i;
							}
							else
							{
								oids.splice(ii, 1);
							}
						
							break;
						}
					}
				
					if (quantity > 0 && !found)
					{
						oids.push(quantity + OTABO_OID_SEP + i);
					}
				
					span.innerHTML = quantity;
					updateTotals();
				}
				
			})(qty, optional, i);
		}
				
		var c = 0;
		var num = Object.keys(groups).length;
		for (var ii in groups)
		{
			if (groups[ii].indexOf(optional.id) != -1 || c == num - 1)
			{
				uls[ii].appendChild(li);
				break;
			}
			
			c++;
		}
	}
		
	for (var i in uls)
	{
		if (uls[i].children.length == 0)
		{
			continue;
		}
		
		var h1 = document.createElement('h1');
		h1.innerHTML = _S['booking_optionals_' + i];
		div.appendChild(h1);
		
		div.appendChild(uls[i]);
		var dd = document.createElement('div');
		dd.style.clear = 'both';
		div.appendChild(dd);
	}
	
	var totals = parseFloat(quote.rate);
	if (cid)
	{
		totals += parseFloat(quote.coverages[cid].rate);
	}

	var oidStr = '';
	for (var ii in quote.optionals)
	{
		var optional = quote.optionals[ii];
		if (optional.id && oids.indexOf(ii) != -1)
		{
			totals += parseFloat(optional.rate);
			oidStr += (oidStr == '' ? '' : ',') + ii;
		}
		else if (optional.required && optional.required == true)
		{
			totals += parseFloat(optional.rate);
		}
	}
	
	oidStr = encodeURI(oidStr);
	
	var thisDiv = document.createElement('div');
	div.appendChild(thisDiv);
	thisDiv.className = 'rate';
	
	var span = document.createElement('span');
	thisDiv.appendChild(span);
	span.innerHTML = _S.booking_optionals_totals;
	
	var span = document.createElement('span');
	thisDiv.appendChild(span);
	span.id = 'otabo_optionals_totals';
	span.innerHTML = otaboFormatCurrency(totals);
	
	var button = document.createElement('button');
	thisDiv.appendChild(button);
	button.innerHTML = _S.booking_optionals_next;
	
	thisDiv.appendChild(nextLink);
	nextLink.href = OTABO_BOOKING_URL + '&oid=' + oidStr;
	nextLink.appendChild(button);
}

function otaboLoadForm(osd, id, params)
{
	var form = document.getElementById(id + 'form');
	form.disabled = true;
	
	if (params.form_overflow_fix && params.form_overflow_fix > 0)
	{
		var e = form;
		var i = 0;
		
		while (e.parentNode && i++ < params.form_overflow_fix)
		{
			e = e.parentNode;
			e.style.overflow = 'visible';
		}
	}
	
	// Should we show the young driver flag?
	var youngDriver = null;
	if (params.form_young_driver)
	{
		var e = document.getElementById(id + 'young_driver_tick');
		if (e)
		{
			e.style.display = 'inherit';
			youngDriver = document.getElementById(id + 'young_driver');
		}
	}

	if (!params.form_one_way_trips)
	{
		document.getElementById(id + 'checkin_base_select_tick').style.display = 'none';
		document.getElementById(id + 'checkin_base_label').style.display = 'none';
		document.getElementById(id + 'checkin_base').parentNode.style.display = 'none';
	}
	
	// Hide the checkin base selection?
	if (!params.form_checkin_base_select)
	{
		document.getElementById(id + 'checkin_base_select_tick').style.display = 'none';
		document.getElementById(id + 'checkin_base_label').style.display = 'none';
		document.getElementById(id + 'checkin_base_select').style.display = 'none';
	}
	
	// Should we show the time pickers?
	var defaultCheckoutTime = null;
	var defaultCheckoutTimeOffset = 30;
	if (params.form_default_checkout_time && params.form_default_checkout_time.length == 5)
	{
		defaultCheckoutTime = params.form_default_checkout_time;
		document.getElementById(id + 'checkout_time').parentNode.style.display = 'none';
	}
	
	if (params.form_default_checkout_time_offset)
	{
		defaultCheckoutTimeOffset = params.form_default_checkout_time_offset;
	}

	var defaultCheckinTime = null;
	if (params.form_default_checkin_time && params.form_default_checkin_time.length == 5)
	{
		defaultCheckinTime = params.form_default_checkin_time;
		document.getElementById(id + 'checkin_time').parentNode.style.display = 'none';
	}
	
	var defaultCheckoutDayOffset = params.form_default_checkout_day_offset ? parseInt(params.form_default_checkout_day_offset) : 0;
	var defaultCheckinDayOffset = params.form_default_checkin_day_offset ? parseInt(params.form_default_checkin_day_offset) : 2;
		
	otaboRequest(['cmd', 'bases', 'osd', osd], function(success, response)
	{
		if (success && response)
		{
			// Filter the bases?
			if (params.form_bases && params.form_bases.length > 0)
			{
				var thisBases = [];
				for (var i in params.form_bases)
				{
					var base = params.form_bases[i].toLowerCase().trim();
					for (var j in response.base)
					{
						if (response.base[j].name.toLowerCase() == base)
						{
							thisBases.push(response.base[j]);
							break;
						}
					}
				}
				
				response.base = thisBases;
			}
			
			if (!response.hasOwnProperty('checkin_time'))
			{
				response.checkout_time = new Date();
				response.checkout_time.setDate(response.checkout_time.getDate() + defaultCheckoutDayOffset);
				response.checkout_time.setHours(defaultCheckoutTime ? defaultCheckoutTime.substr(0, 2) : response.checkout_time.getHours() + 1, defaultCheckoutTime ? defaultCheckoutTime.substr(3, 2) : 0, 0, 0);
				
				if (defaultCheckoutTime && response.checkout_time < new Date())
				{
					response.checkout_time = new Date();

					var min = response.checkout_time.getMinutes() + (defaultCheckoutTimeOffset % 60);
					min = (parseInt(min / 15) + 1) * 15;
					response.checkout_time.setHours(response.checkout_time.getHours() + parseInt(defaultCheckoutTimeOffset / 60), min, 0, 0);
				}

				response.checkin_time = new Date(response.checkout_time.getTime());
				response.checkin_time.setDate(response.checkin_time.getDate() + defaultCheckinDayOffset);
				response.checkin_time.setHours(defaultCheckinTime ? defaultCheckinTime.substr(0, 2) : response.checkout_time.getHours(), defaultCheckinTime ? defaultCheckinTime.substr(3, 2) : 0, 0, 0);

				response.checkout_time = otaboFormatDate(response.checkout_time, true);
				response.checkin_time = otaboFormatDate(response.checkin_time, true);
			}
			
			var otaboInput =
			{
				checkout_base : response.checkout_base ? response.checkout_base : null,
				checkout_time : response.checkout_time,
				checkin_base : response.checkin_base ? response.checkin_base : null,
				checkin_time : response.checkin_time,
				clazz : null,
				young_driver : response.young_driver && response.young_driver != false && response.young_driver != 0 && response.young_driver != '0' ? true : false,
			};

			if (youngDriver && otaboInput.young_driver != false)
			{
				youngDriver.checked = true;
			}

			var today = new Date();
			today.setHours(0, 0, 0, 0);

			///
			///
			// CLASSES
			///
			///
			var clazzes = document.getElementById(id + 'form_classes');
			var ul = document.createElement('ul');
			clazzes.appendChild(ul);
			
			if (params.form_classes && response.clazz && response.clazz.length > 0)
			{
				clazzes.classList.add('visible');
				
				for (var i in response.clazz)
				{
					response.clazz[i].id = i;
				}

				if (params.form_classes_list && params.form_classes_list.length > 0)
				{
					var newClasses = [];
					for (var i in params.form_classes_list)
					{
						for (var j in response.clazz)
						{
							if (params.form_classes_list[i].toLowerCase() == response.clazz[j].name.toLowerCase())
							{
								newClasses.push(response.clazz[j]);
								break;
							}
						}
					}
					
					response.clazz = newClasses;
				}

				otaboInput.clazz = otaboInput.clazz ? otaboInput.clazz : response.clazz[0].id;
				
				for (var i in response.clazz)
				{
					var clazz = response.clazz[i];
					var li = document.createElement('li');
					ul.appendChild(li);
					li.onclick = ((i, clazz) =>
					{
						return () =>
						{
							otaboInput.clazz = clazz.id;
							for (var ii = 0; ii < ul.children.length; ii++)
							{
								if (ii == otaboInput.clazz)
								{
									ul.children[ii].classList.add('selected');
								}
								else
								{
									ul.children[ii].classList.remove('selected');
								}
								
								if (ii == otaboInput.clazz)
								{
									if (ul.children[ii].offsetLeft - 2 < ul.scrollLeft)
									{
										ul.scrollLeft = ul.children[ii].offsetLeft - 2;
									}
									else if (ul.children[ii].offsetLeft + ul.children[ii].offsetWidth - 2 > ul.scrollLeft + ul.offsetWidth)
									{
										ul.scrollLeft = ul.children[ii].offsetLeft + ul.children[ii].offsetWidth - ul.offsetWidth - 2;
									}
								}
							}
						}
					})(i, clazz);
					
					if (clazz.icon && clazz.icon.length > 0)
					{
						var img = document.createElement('img');
						li.appendChild(img);
						img.src = clazz.icon;
					}

					var span = document.createElement('span');
					li.appendChild(span);
					span.innerHTML = clazz.name;
					
					if (otaboInput.clazz == clazz.id)
					{
						li.onclick();
					}
				}
				
				var leftScroller = document.createElement('span');
				leftScroller.className = 'otabo_form_classes_lscroller';
				leftScroller.id = id + 'form_classes_lscroller';
				clazzes.appendChild(leftScroller);
				leftScroller.onclick = () =>
				{
					var width = parseInt(ul.children[0].offsetWidth) + parseInt(window.getComputedStyle(ul.children[0]).marginRight.replace('px', ''));
					var index = Math.floor(ul.scrollLeft / width);
					if (index <= otaboInput.clazz)
					{
						ul.children[Math.max(0, index - 1)].onclick();
					}
					else
					{
						ul.scrollLeft = ul.children[Math.max(0, index - 1)].offsetLeft - 2;
					}
				};
			
				var rightScroller = document.createElement('span');
				rightScroller.className = 'otabo_form_classes_rscroller';
				rightScroller.id = id + 'form_classes_rscroller';
				clazzes.appendChild(rightScroller);
				rightScroller.onclick = () =>
				{
					var width = parseInt(ul.children[0].offsetWidth) + parseInt(window.getComputedStyle(ul.children[0]).marginRight.replace('px', ''));
					var index = Math.floor(ul.scrollLeft / width);
					if (index >= otaboInput.clazz)
					{
						ul.children[index + 1].onclick();
					}
					else
					{
						ul.scrollLeft = ul.children[index + 1].offsetLeft;
					}
				};
						
				ul.onscroll = () =>
				{
					leftScroller.style.display = ul.scrollLeft > 0 ? 'block' : 'none';
					rightScroller.style.display = ul.scrollLeft < ul.scrollWidth - ul.offsetWidth - 12 ? 'block' : 'none';
				}

				leftScroller.style.display = ul.scrollLeft > 0 ? 'block' : 'none';
				rightScroller.style.display = ul.scrollLeft < ul.scrollWidth - ul.offsetWidth - 12 ? 'block' : 'none';
			}
			else
			{
				clazzes.parentNode.removeChild(clazzes);
				
				if (params.form_class && response.clazz && response.clazz.length > 0)
				{
					for (var j in response.clazz)
					{
						if (params.form_class.toLowerCase() == response.clazz[j].name.toLowerCase())
						{
							otaboInput.clazz = j;
							break;
						}
					}
				}
			}

			// POPUPS
			var checkinBases = [];

			var checkoutBase = document.getElementById(id + 'checkout_base_list');
			var checkinBase = document.getElementById(id + 'checkin_base_list');
			var checkoutDateCalendar = document.getElementById(id + 'checkout_date_calendar');
			var checkinDateCalendar = document.getElementById(id + 'checkin_date_calendar');

			var checkoutDate = document.getElementById(id + 'checkout_date');
			var checkoutDateError = document.getElementById(id + 'checkout_date_error');
			var checkoutDateTable = document.getElementById(id + 'checkout_date_table');
			var checkoutTime = document.getElementById(id + 'checkout_time');
			var checkoutTimeInput = document.getElementById(id + 'checkout_time_input');
			var checkinDate = document.getElementById(id + 'checkin_date');
			var checkinDateError = document.getElementById(id + 'checkin_date_error');
			var checkinDateTable = document.getElementById(id + 'checkin_date_table');
			var checkinTime = document.getElementById(id + 'checkin_time');
			var checkinTimeInput = document.getElementById(id + 'checkin_time_input');
			
			var checkHours = () =>
			{
				if (!checkoutDate.parentNode || !checkoutTime.parentNode || !checkinDate.parentNode || !checkinTime.parentNode)
				{
					return false;
				}
				
				checkoutDateError.innerHTML = '';
				checkoutDateError.style.display = 'none';

				checkinDateError.innerHTML = '';
				checkinDateError.style.display = 'none';

				checkoutDate.parentNode.classList.remove('error');
				checkoutTime.parentNode.classList.remove('error');
				checkinDate.parentNode.classList.remove('error');
				checkinTime.parentNode.classList.remove('error');
				
				var error = false;
				
				var base = otaboInput.checkout_base;
				var date = null;
				var hours = null;
				
				if (base && otaboInput.checkout_time)
				{
					date = new Date(otaboInput.checkout_time.replace(' ', 'T') + '+00:00');
					
					var dateError = false;
					var dateStr = otaboFormatDate(date, true).substr(0, 10);
					var open = base.closed_days.length > 0 ? false : true;
					for (days in base.closed_days)
					{
						days = base.closed_days[days];
						if (days && days.indexOf(dateStr) != -1)
						{
							continue;
						}
						else
						{
							open = true;
							break;
						}
					}
					
					if (!open)
					{
						checkoutDate.parentNode.classList.add('error');
						checkoutDateError.innerHTML = _S.booking_error_checkout_date;
						checkoutDateError.style.display = 'block';
						
						dateError = true;
					}
					
					if (!dateError && (!base.hours || !base.hours[date.getDay()] || base.hours[date.getDay()] == 0))
					{
						checkoutDate.parentNode.classList.add('error');
						checkoutTime.parentNode.classList.add('error');
						checkoutDateError.innerHTML = _S.booking_error_checkout_date;
						checkoutDateError.style.display = 'block';

						error = true;
					}
					else if (!dateError)
					{
						var time = otaboFormatDate(date, false, 'time');
						
						hours = null;
						if (base.custom_days && base.custom_days.length > 0)
						{
							for (var dd in base.custom_days)
							{
								if (base.custom_days[dd].hasOwnProperty(dateStr))
								{
									if (hours == null)
									{
										hours = base.custom_days[dd][dateStr];
									}
									else
									{
										hours.push(base.custom_days[dd][dateStr]);
									}
								}
							}
						}
						
						if (hours == null)
						{
							hours = base.hours[date.getDay()];
						}

						for (var i in hours)
						{
							if (hours[i][0] <= time && time <= hours[i][1])
							{
								time = null;
								break;
							}
						}
						
						if (time)
						{
							checkoutTime.parentNode.classList.add('error');
							checkoutDateError.innerHTML = _S.booking_error_checkout_time;
							checkoutDateError.style.display = 'block';

							error = true;
						}
					}
				}
				else if (!otaboInput.checkout_time && checkoutDate.value != '')
				{
					checkoutDate.parentNode.classList.add('error');
					checkoutDateError.innerHTML = _S.booking_error_checkout_date_invalid;
					checkoutDateError.style.display = 'block';

					error = true;
				}
				
				var time = date ? otaboFormatDate(date, false, 'time') : null;
				if (time && checkoutTimeInput.value.trim() != time)
				{
					error = true;
					checkoutTime.parentNode.classList.add('error');
					checkoutDateError.innerHTML = _S.booking_error_checkout_time;
					checkoutDateError.style.display = 'block';					
				}
				else
				{				
					var times = checkoutTime.children;
					for (var i = 0; i < times.length; i++)
					{
						var t = times[i].textContent;
						if (hours)
						{
							for (var ii in hours)
							{
								if (hours[ii][0] <= t && t <= hours[ii][1])
								{
									t = null;
									break;
								}
							}
						}
						else
						{
							t = null;
						}
					
						if (time && !t && times[i].textContent == time)
						{
							time = null;
						}
					
						times[i].out = t ? true : false;
						times[i].style.display = t ? 'none' : 'block';
					}

					if (time)
					{
						error = true;
						checkoutTime.parentNode.classList.add('error');
						checkoutDateError.innerHTML = _S.booking_error_checkout_time;
						checkoutDateError.style.display = 'block';
					}
				}
				
				var base = !otaboInput.checkin_base && !document.getElementById(id + 'checkin_base_select_tick').checked ? otaboInput.checkout_base : otaboInput.checkin_base;
				var date = null;
				if (base && otaboInput.checkin_time)
				{
					date = new Date(otaboInput.checkin_time.replace(' ', 'T') + '+00:00');

					var dateError = false;
					var dateStr = otaboFormatDate(date, true).substr(0, 10);
					var open = base.closed_days.length > 0 ? false : true;
					for (days in base.closed_days)
					{
						days = base.closed_days[days];
						if (days && days.indexOf(dateStr) != -1)
						{
							continue;
						}
						else
						{
							open = true;
							break;
						}
					}
					
					if (!open)
					{
						checkinDate.parentNode.classList.add('error');
						checkinDateError.innerHTML = _S.booking_error_checkin_date;
						checkinDateError.style.display = 'block';

						dateError = true;
					}
					
					if (!dateError && (!base.hours || !base.hours[date.getDay()] || base.hours[date.getDay()] == 0))
					{
						checkinDate.parentNode.classList.add('error');
						checkinTime.parentNode.classList.add('error');
						checkinDateError.innerHTML = _S.booking_error_checkin_date;
						checkinDateError.style.display = 'block';

						error = true;
					}
					else if (!dateError)
					{
						var time = otaboFormatDate(date, false, 'time');
						
						hours = null;
						if (base.custom_days && base.custom_days.length > 0)
						{
							for (var dd in base.custom_days)
							{
								if (base.custom_days[dd].hasOwnProperty(dateStr))
								{
									if (hours == null)
									{
										hours = base.custom_days[dd][dateStr];
									}
									else
									{
										hours.push(base.custom_days[dd][dateStr]);
									}
								}
							}
						}
						
						if (hours == null)
						{
							hours = base.hours[date.getDay()];
						}
						
						for (var i in hours)
						{
							if (hours[i][0] <= time && time <= hours[i][1])
							{
								time = null;
								break;
							}
						}
						
						if (time)
						{
							checkinTime.parentNode.classList.add('error');
							checkinDateError.innerHTML = _S.booking_error_checkin_time;
							checkinDateError.style.display = 'block';

							error = true;
						}
					}
				}
				else if (!otaboInput.checkin_time && checkinDate.value != '')
				{
					checkinDate.parentNode.classList.add('error');
					checkinDateError.innerHTML = _S.booking_error_checkin_date_invalid;
					checkinDateError.style.display = 'block';

					error = true;
				}

				var time = date ? otaboFormatDate(date, false, 'time') : null;
				if (time && checkinTimeInput.value.trim() != time)
				{
					error = true;
					checkinTime.parentNode.classList.add('error');
					checkinDateError.innerHTML = _S.booking_error_checkin_time;
					checkinDateError.style.display = 'block';					
				}
				else
				{
					var times = checkinTime.children;
					for (var i = 0; i < times.length; i++)
					{
						var t = times[i].textContent;
						if (hours)
						{
							for (var ii in hours)
							{
								if (hours[ii][0] <= t && t <= hours[ii][1])
								{
									t = null;
									break;
								}
							}
						}
						else
						{
							t = null;
						}
					
						if (time && !t && times[i].textContent == time && checkinTimeInput.value == time)
						{
							time = null;
						}
					
						times[i].out = t ? true : false;
						times[i].style.display = t ? 'none' : 'block';
					}
				
					if (time)
					{
						error = true;
						checkinTime.parentNode.classList.add('error');
						checkinDateError.innerHTML = _S.booking_error_checkin_time;
						checkinDateError.style.display = 'block';
					}
				}
				
				if (otaboInput.checkout_time && otaboInput.checkin_time && otaboInput.checkout_time >= otaboInput.checkin_time)
				{
					error = true;
					checkinDate.parentNode.classList.add('error');
					checkinTime.parentNode.classList.add('error');

					checkinDateError.innerHTML = _S.booking_error_checkin_date_before;
					checkinDateError.style.display = 'block';
				}
				
				return !error;
			};

			///
			///
			// CHECKOUT BASE
			///
			///
			var checkoutBaseInput = document.getElementById(id + 'checkout_base');
			var checkinBaseInput = document.getElementById(id + 'checkin_base');
			checkoutBaseInput.onfocus = function()
			{
				checkoutBaseInput.parentNode.classList.remove('error');

				checkoutBase.style.display = 'block';
				checkinBase.style.display = 'none';
				checkoutDateCalendar.style.display = 'none';
				checkinDateCalendar.style.display = 'none';
				checkinTime.style.display = 'none';
				checkinTime.style.display = 'none';
			}

			checkoutBaseInput.onblur = function()
			{
				if (!otaboInput.checkout_base || otaboInput.checkout_base.name != this.value)
				{
					var selected = false;
					for (var i = 0; i < checkoutBase.children.length; i++)
					{
						if (window.getComputedStyle(checkoutBase.children[i], null).display != 'none')
						{
							selected = true;
							checkoutBase.children[i].onmousedown();		
							
							break;					
						}
					}
					
					if (!selected)
					{
						checkoutBaseInput.parentNode.classList.add('error');
					}
				}

				checkoutBase.style.display = 'none';
			}

			checkoutBaseInput.onkeyup = function(e)
			{
				var pattern = new RegExp('.*' + checkoutBaseInput.value + '.*', 'i');
				for (var i = 0; i < checkoutBase.children.length; i++)
				{
					var li = checkoutBase.children[i];
					li.style.display = li.innerHTML && pattern.test(li.innerHTML) ? 'block' : 'none';
				}
			}
			
			checkoutBaseInput.onkeydown = function(e)
			{
				var res = true;
				if (e.keyCode == 9)
				{
					checkoutBaseInput.blur();
					if (window.getComputedStyle(checkinBaseInput.parentNode, null).display != 'none')
					{
						checkinBaseInput.focus();
					}
					else
					{
						checkoutDate.focus();
					}
					
					res = false;
				}
				
				return res;
			}

			for (var i in response.base)
			{
				var li = document.createElement('li');
				checkoutBase.appendChild(li);
 				li.innerHTML = response.base[i].name;
 				li.onmousedown = function(base)
 				{
 					return function(e)
 					{					
 						checkoutBase.parentNode.classList.add('input');
						checkoutBaseInput.value = base.name;

						otaboInput.checkout_base = base;
						otaboInput.checkin_base = null;
						
						checkHours();
												
						checkinBaseInput.value = '';

						e && e.preventDefault();
						e && e.stopPropagation();

						checkoutBaseInput.blur();
					}

 				}(response.base[i]);
 				
 				if (otaboInput.checkout_base && JSON.stringify(response.base[i].uid) == JSON.stringify(otaboInput.checkout_base.uid))
 				{
 					checkoutBaseInput.value = response.base[i].name;
 				}
 				else if (checkoutBaseInput.value.length > 0 && checkoutBaseInput.value == response.base[i].name
 						&& otaboInput.checkout_base == null)
 				{
 					otaboInput.checkout_base = response.base[i];
 					checkHours();
 				}
 			}

			///
			///
			// CHECKIN BASE
			///
			///
			document.getElementById(id + 'checkin_base_select_tick').onclick = function()
			{
				var shown = document.getElementById(id + 'checkin_base_select').checked;
				document.getElementById(id + 'checkin_base_label').style.display = shown ? 'block' : 'none';
				document.getElementById(id + 'checkin_base').parentNode.style.display = shown ? 'block' : 'none';
			};
			
			if (document.getElementById(id + 'checkin_base_select').checked
					&& window.getComputedStyle(document.getElementById(id + 'checkin_base')).display != 'block')
			{
				document.getElementById(id + 'checkin_base_select_tick').click();
			}
			
			var checkinBaseInput = document.getElementById(id + 'checkin_base');
			checkinBaseInput.onfocus = function()
			{
				while (checkinBase.children.length > 0)
				{
					checkinBase.removeChild(checkinBase.children[0]);
				}
				
				// Add all the bases for the corresponding checkout base.
				if (otaboInput.checkout_base)
				{
					for (var i = 0; i < response.base.length; i++)
					{
						for (var j = 0; j < otaboInput.checkout_base.uuid.length; j++)
						{
							if (response.base[i].uuid.indexOf(otaboInput.checkout_base.uuid[j]) != -1)
							{
								var li = document.createElement('li');
								checkinBase.appendChild(li);
								li.innerHTML = response.base[i].name;
								li.onmousedown = function(base)
								{
									return function(e)
									{
										checkinBase.parentNode.classList.add('input');
										checkinBaseInput.value = base.name;

										otaboInput.checkin_base = base;

										e && e.preventDefault();
										e && e.stopPropagation();

										checkinBaseInput.blur();
									}

								}(response.base[i]);

								if (otaboInput.checkin_base && response.base[i].uid == otaboInput.checkin_base.uid)
								{
									checkinBaseInput.value = response.base[i].name;
								}
								else if (otaboInput.checkin_base == null && checkinBaseInput.value.length > 0
										&& checkinBaseInput.value == response.base[i].name)
								{
									otaboInput.checkin_base = response.base[i];
								}
								
								break;
							}
						}
					}
				}
				else
				{
					var li = document.createElement('li');
					li.innerHTML = _S.checkout_base_select;
					checkinBase.appendChild(li);
				}
			
				checkoutBase.style.display = 'none';
				checkinBase.style.display = 'block';
				checkoutDateCalendar.style.display = 'none';
				checkinDateCalendar.style.display = 'none';
				checkinTime.style.display = 'none';
				checkinTime.style.display = 'none';
			}

			checkinBaseInput.onblur = function()
			{
				if (!otaboInput.checkin_base || otaboInput.checkin_base.name != this.value)
				{
					var selected = false;
					for (var i = 0; i < checkinBase.children.length; i++)
					{
						if (window.getComputedStyle(checkinBase.children[i], null).display != 'none'
								&& checkinBase.children[i].onmousedown)
						{
							selected = true;
							checkinBase.children[i].onmousedown();							
							
							break;
						}
					}
					
					if (!selected)
					{
						checkinBaseInput.parentNode.classList.add('error');
					}
				}
				
				checkinBase.style.display = 'none';
			}

			checkinBaseInput.onkeyup = function()
			{
				var pattern = new RegExp('.*' + checkinBaseInput.value + '.*', 'i');
				for (var i = 0; i < checkinBase.children.length; i++)
				{
					var li = checkinBase.children[i];
					li.style.display = li.innerHTML && pattern.test(li.innerHTML) ? 'block' : 'none';
				}
			}
			
			checkinBaseInput.onkeydown = function(e)
			{
				var res = true;
				if (e.keyCode == 9)
				{
					checkinBaseInput.blur();
					checkoutDate.click();
					
					res = false;
				}
				
				return res;
			}
			
			if (otaboInput.checkout_base != null
					&& otaboInput.checkin_base == null && checkinBaseInput.value.length > 0)
			{
				for (var i = 0; i < response.base.length; i++)
				{
					for (var j = 0; j < otaboInput.checkout_base.uuid.length; j++)
					{
						if (response.base[i].uuid.indexOf(otaboInput.checkout_base.uuid[j]) != -1)
						{
							if (checkinBaseInput.value == response.base[i].name)
							{
								otaboInput.checkin_base = response.base[i];
							}
							
							break;
						}
					}
					
					if (otaboInput.checkin_base != null)
					{
						break;
					}
				}
			}
			
			///
			///
			// CHECKOUT DATE
			///
			///
			var checkoutDateTableDate = new Date();
 			checkoutDateTableDate.setDate(1);
 			checkoutDateTableDate.setHours(0, 0, 0, 0);

 			checkoutDate.value = otaboFormatDate(otaboInput.checkout_time, false, 'date');
			checkoutDate.onfocus = function()
			{
				checkoutDate.parentNode.classList.remove('error');

				checkoutBase.style.display = 'none';
				checkinBase.style.display = 'none';
				checkoutDateCalendar.style.display = 'block';
				checkinDateCalendar.style.display = 'none';
				checkoutTime.style.display = 'none';
				checkinTime.style.display = 'none';

				loadMonth(document.getElementById(id + 'checkout_date_title'), document.getElementById(id + 'checkout_date_left'),
						document.getElementById(id + 'checkout_date_right'), checkoutDateTable, checkoutDateTableDate);
			};
			
			checkoutDate.onkeyup = function()
			{
				var date = otaboFormatDate(this.value.trim(), true, 'date');
				if (date)
				{
					checkoutDateTableDate = new Date(date.replace(' ', 'T') + '+00:00');

					checkoutDateTableDate.setDate(1);
		 			checkoutDateTableDate.setHours(0, 0, 0, 0);
		 			
					loadMonth(document.getElementById(id + 'checkout_date_title'), document.getElementById(id + 'checkout_date_left'),
							document.getElementById(id + 'checkout_date_right'), checkoutDateTable, checkoutDateTableDate);
					
					var e = document.getElementById(id + 'checkout_' + new Date(date.replace(' ', 'T') + '+00:00').getTime());
					if (e)
					{
						e.onmousedown();
						loadMonth(document.getElementById(id + 'checkout_date_title'), document.getElementById(id + 'checkout_date_left'),
								document.getElementById(id + 'checkout_date_right'), checkoutDateTable, checkoutDateTableDate);
					}
				}
			}
			
			checkoutDate.onblur = function()
			{
				var date = otaboFormatDate(this.value, true, 'date');
				if (!date)
				{
					otaboInput.checkout_time = null;
				}
			
				checkHours();
				if (!checkoutDateCalendar.isMouseOver)
				{
					checkoutDateCalendar.style.display = 'none';
				}
			}
			
			checkoutDateCalendar.onmouseover = function(e)
			{
				this.isMouseOver = true;
			}
			
			checkoutDateCalendar.onmouseout = function(e)
			{
				this.isMouseOver = false;
			}
			
			///
			///
			// CHECKOUT TIME
			///
			///			
			var time = new Date(2000, 1, 1, 0, 0, 0);
			var day = time.getDate();

			while (time.getDate() == day)
			{
				var li = document.createElement('li');
				checkoutTime.appendChild(li);
 				li.innerHTML = otaboFormatDate(time, false, 'time');
 				li.onmousedown = function()
 				{
					checkoutTime.parentNode.classList.add('input');
					checkoutTimeInput.value = this.innerHTML;

					otaboInput.checkout_time = otaboFormatDate(otaboFormatDate(otaboInput.checkout_time, false, 'date') + ' ' + this.innerHTML, true);

 				};

				time.setMinutes(time.getMinutes() + 15);
			}

			checkoutTimeInput.value = otaboFormatDate(otaboInput.checkout_time, false, 'time');
			
			checkoutTimeInput.onfocus = function()
			{
				checkoutTimeInput.parentNode.classList.remove('error');

				checkoutBase.style.display = 'none';
				checkinBase.style.display = 'none';
				checkoutDateCalendar.style.display = 'none';
				checkinDateCalendar.style.display = 'none';
				checkoutTime.style.display = 'block';
				checkinTime.style.display = 'none';
				
				for (var i in checkoutTime.children)
				{
					if (checkoutTime.children[i].textContent.startsWith(checkoutTimeInput.value.trim()))
					{
						checkoutTime.scrollTop = Math.min(checkoutTime.children[i].offsetTop, checkoutTime.scrollHeight - checkoutTime.offsetHeight);
						break;
					}
				}
			}
			
			checkoutTimeInput.onblur = function()
			{
				if (!checkoutTimeInput.value || checkoutTimeInput.value != otaboFormatDate(otaboInput.checkout_time, false, 'time'))
				{
					var selected = false;
					for (var i = 0; i < checkoutTime.children.length; i++)
					{
						var li = checkoutTime.children[i];
						if (!li.out)
						{
							if (checkoutTimeInput.value.trim() == li.textContent)							
							{
								selected = true;
								li.onmousedown();	
								
								break;						
							}
						}
					}
					
					if (!selected)
					{
						otaboInput.checkout_time = otaboFormatDate(otaboFormatDate(otaboInput.checkout_time, false, 'date'), true)
					}
				}
				
				checkoutTime.style.display = 'none';
				checkHours();
			}

			checkoutTimeInput.onkeyup = function(e)
			{
				if (e && (e.which >= 45 || e.which == 8))
				{
					var pattern = new RegExp(checkoutTimeInput.value.trim() + '.*', 'i');
					for (var i = 0; i < checkoutTime.children.length; i++)
					{
						var li = checkoutTime.children[i];
						li.style.display = !li.out && li.innerHTML && pattern.test(li.innerHTML) ? 'block' : 'none';
					}
				}
			}
			
			///
			///
			// CHECKIN DATE
			///
			///
			var checkinDateTableDate = new Date();
			checkinDateTableDate.setDate(1);
 			checkinDateTableDate.setHours(0, 0, 0, 0);

 			checkinDate.value = otaboFormatDate(otaboInput.checkin_time, false, 'date');
			checkinDate.onfocus = function()
			{
				checkinDate.parentNode.classList.remove('error');
				checkinTimeInput.parentNode.classList.remove('error');

				var shown = window.getComputedStyle(checkinDateCalendar, null).display != 'none';
				if (!shown)
				{
					checkoutBaseInput.blur();
					checkinBaseInput.blur();
					checkoutDateCalendar.style.display = 'none';
					checkoutTimeInput.blur();
					checkinTimeInput.blur();

					loadMonth(document.getElementById(id + 'checkin_date_title'), document.getElementById(id + 'checkin_date_left'),
							document.getElementById(id + 'checkin_date_right'), checkinDateTable, checkinDateTableDate);
				}

				checkinDateCalendar.style.display = shown ? 'none' : 'block';
			};

			checkinDate.onkeyup = function()
			{
				var date = otaboFormatDate(this.value.trim(), true, 'date');
				if (date)
				{
					checkinDateTableDate = new Date(date.replace(' ', 'T') + '+00:00');
					checkinDateTableDate.setDate(1);
		 			checkinDateTableDate.setHours(0, 0, 0, 0);
		 			
					loadMonth(document.getElementById(id + 'checkin_date_title'), document.getElementById(id + 'checkin_date_left'),
							document.getElementById(id + 'checkin_date_right'), checkinDateTable, checkinDateTableDate);

					var e = document.getElementById(id + 'checkin_' + new Date(date.replace(' ', 'T') + '+00:00').getTime());
					if (e)
					{
						e.onmousedown();
						loadMonth(document.getElementById(id + 'checkin_date_title'), document.getElementById(id + 'checkin_date_left'),
								document.getElementById(id + 'checkin_date_right'), checkinDateTable, checkinDateTableDate);
					}
				}
			}

			checkinDate.onblur = function()
			{
				var date = otaboFormatDate(this.value, true, 'date');
				if (!date)
				{
					otaboInput.checkin_time = null;
				}
				
				checkHours();
				if (!checkinDateCalendar.isMouseOver)
				{
					checkinDateCalendar.style.display = 'none';
				}
			}
			
			checkinDateCalendar.onmouseover = function(e)
			{
				this.isMouseOver = true;
			}
			
			checkinDateCalendar.onmouseout = function(e)
			{
				this.isMouseOver = false;
			}
			
			///
			///
			// CHECKIN TIME
			///
			///			
			var time = new Date(2000, 1, 1, 0, 0, 0);
			var day = time.getDate();

			while (time.getDate() == day)
			{
				var li = document.createElement('li');
				checkinTime.appendChild(li);
 				li.innerHTML = otaboFormatDate(time, false, 'time');
 				li.onmousedown = function()
 				{
					checkinTime.parentNode.classList.add('input');
					checkinTimeInput.value = this.innerHTML;

					otaboInput.checkin_time = otaboFormatDate(otaboFormatDate(otaboInput.checkin_time, false, 'date') + ' ' + this.innerHTML, true);

 				};

				time.setMinutes(time.getMinutes() + 15);
			}

			checkinTimeInput.value = otaboFormatDate(otaboInput.checkin_time, false, 'time');
			
			checkinTimeInput.onfocus = function()
			{
				checkinDate.parentNode.classList.remove('error');
				checkinTimeInput.parentNode.classList.remove('error');

				checkoutBase.style.display = 'none';
				checkinBase.style.display = 'none';
				checkoutDateCalendar.style.display = 'none';
				checkinDateCalendar.style.display = 'none';
				checkoutTime.style.display = 'none';
				checkinTime.style.display = 'block';
				
				for (var i in checkinTime.children)
				{
					if (checkinTime.children[i].innerHTML.startsWith(checkinTimeInput.value))
					{
						checkinTime.scrollTop = Math.min(checkinTime.children[i].offsetTop, checkinTime.scrollHeight - checkinTime.offsetHeight);
						break;
					}
				}
			}
			
			checkinTimeInput.onblur = function()
			{				
				if (!checkinTimeInput.value || checkinTimeInput.value != otaboFormatDate(otaboInput.checkin_time, false, 'time'))
				{
					var selected = false;
					for (var i = 0; i < checkinTime.children.length; i++)
					{
						var li = checkinTime.children[i];
						if (!li.out)
						{
							if (checkinTimeInput.value.trim() == li.textContent)
							{
								selected = true;
								li.onmousedown();								
								
								break;
							}
						}
					}

					if (!selected)
					{
						otaboInput.checkin_time = otaboFormatDate(otaboFormatDate(otaboInput.checkin_time, false, 'date'), true)
					}
				}
				
				checkinTime.style.display = 'none';
				checkHours();
			}
			
			checkinTimeInput.onkeydown = function(e)
			{
				if (e && e.which == 9)
				{
					e.preventDefault();
					e.stopPropagation();
					
					this.blur();
				}
			}

			checkinTimeInput.onkeyup = function(e)
			{
				if (e && (e.which >= 45 || e.which == 8))
				{
					var pattern = new RegExp(checkinTimeInput.value.trim() + '.*', 'i');
					for (var i = 0; i < checkinTime.children.length; i++)
					{
						var li = checkinTime.children[i];
						li.style.display = !li.out && li.innerHTML && pattern.test(li.innerHTML) ? 'block' : 'none';
					}
				}
			}

			form.onmousedown = function(e)
			{
				var els =
				[
					[ checkoutBaseInput, checkoutBase ],
					[ checkinBaseInput, checkinBase ], 
					[ checkoutDate, checkoutDateCalendar ],
					[ checkinDate, checkinDateCalendar ],
					[ checkoutTimeInput, checkoutTime ],
					[ checkinTimeInput, checkinTime ]
				]
				
				for (var i in els)
				{
					if (els[i][0] != document.activeElement)
					{
						els[i][1].style.display = 'none';
					}
				}
			}
	
			///
			///
			// CALENDAR
			///
			///
			var loadMonth = function(title, left, right, table, shownDate)
			{
				title.innerHTML = _S['month_' + shownDate.getMonth()] + ' ' + shownDate.getFullYear();
				left.onmousedown = function(e)
				{
					e.preventDefault();
					e.stopPropagation();

					shownDate.setMonth(shownDate.getMonth() - 1);
					loadMonth(title, left, right, table, shownDate);
				};

				right.onmousedown = function(e)
				{
					e.preventDefault();
					e.stopPropagation();

					shownDate.setMonth(shownDate.getMonth() + 1);
					loadMonth(title, left, right, table, shownDate);
				};

				while (table.firstChild)
				{
					table.removeChild(table.firstChild);
				}

				var date = new Date(shownDate);
				var m = date.getMonth();
				var tr = document.createElement('tr');
				table.appendChild(tr);

				// Empty cells before first day of month.
				var day = date.getDay() == 0 ? 7 : date.getDay();
				while (tr.children.length < day - 1)
				{
					var td = document.createElement('td');
					tr.appendChild(td);
					td.classList.add('none');
					td.onmousedown = function(e)
					{
						e.preventDefault();
						e.stopPropagation();
					}
				}

				// Days.
				while (m == date.getMonth())
				{
					day = date.getDay() == 0 ? 7 : date.getDay();
					if (day == 1 && date.getDate() != 1)
					{
						tr = document.createElement('tr');
						table.appendChild(tr);
					}

					var td = document.createElement('td');
					tr.appendChild(td);
					td.innerHTML = date.getDate();
					
					var base = title.id == id + 'checkout_date_title' && otaboInput.checkout_base ?
							otaboInput.checkout_base : otaboInput.checkin_base;
					var dateError = false;
					if (base)
					{
						var dateStr = (date.getYear() + 1900) + '-' + (date.getMonth() + 1) + '-' + date.getDate();
						var open = base.closed_days.length > 0 ? false : true;
						for (days in base.closed_days)
						{
							days = base.closed_days[days];
							if (days && days.indexOf(dateStr) != -1)
							{
								continue;
							}
							else
							{
								open = true;
								break;
							}
						}
					
						if (!open)
						{
							dateError = true;
						}
					}
					
					// If the base is closed, do not let the user select that day.
					var cibase = !otaboInput.checkin_base && !document.getElementById(id + 'checkin_base_select_tick').checked ? otaboInput.checkout_base : otaboInput.checkin_base;
					if (dateError || title.id == id + 'checkout_date_title' && otaboInput.checkout_base && (!otaboInput.checkout_base.hours
							|| !otaboInput.checkout_base.hours[day % 7] || otaboInput.checkout_base.hours[day % 7].length == 0)
							|| title.id == id + 'checkin_date_title' && cibase && (!cibase.hours || !cibase.hours[day % 7] || cibase.hours[day % 7].length == 0))
					{
						td.classList.add('disabled');
						td.onmousedown = function(e)
						{
							e.preventDefault();
							e.stopPropagation();
						}
					}
					else
					{
						if (title.id == id + 'checkout_date_title' && otaboFormatDate(otaboInput.checkout_time, false, 'date') == otaboFormatDate(date, false, 'date')
								|| title.id == id + 'checkin_date_title' && otaboFormatDate(otaboInput.checkin_time, false, 'date') == otaboFormatDate(date, false, 'date'))
						{
							td.classList.add('selected');
						}

						if (title.id == id + 'checkout_date_title' && date.getTime() >= today.getTime()
								|| title.id == id + 'checkin_date_title' && otaboFormatDate(date, true) >= otaboFormatDate(checkoutDate.value, true, 'date'))
						{
							td.id = id + (title.id == id + 'checkout_date_title' ? 'checkout' : 'checkin') + '_' + date.getTime();
							td.onmousedown = function(title, left, right, table, shownDate, date)
							{
								return function(e)
								{
									if (e)
									{
										e.preventDefault();
										e.stopPropagation();
									}

									var string = otaboFormatDate(date, false, 'date');
									if (title.id == id + 'checkout_date_title')
									{
										var time = otaboInput.checkout_time ? otaboFormatDate(otaboInput.checkout_time, false, 'time') : '00:00';
										date.setHours(parseInt(time.substring(0, 2)), parseInt(time.substring(3, 5)), 0, 0);

										if (defaultCheckoutTime && date < new Date())
										{
											date = new Date();
											
											var min = date.getMinutes() + (defaultCheckoutTimeOffset % 60);
											min = (parseInt(min / 15) + 1) * 15;

											date.setHours(date.getHours() + parseInt(defaultCheckoutTimeOffset / 60), min, 0, 0);
											
											checkoutTimeInput.value = otaboFormatDate(date, false, 'time');
										}
										else if (defaultCheckoutTime)
										{
											date.setHours(parseInt(defaultCheckoutTime.substring(0, 2)), parseInt(defaultCheckoutTime.substring(3, 5)), 0, 0);
											checkoutTimeInput.value = otaboFormatDate(date, false, 'time');
										}

										otaboInput.checkout_time = otaboFormatDate(date, true);

										checkoutDate.value = otaboFormatDate(date, false, 'date');
										
										if (otaboInput.checkin_time <= otaboInput.checkout_time)
										{
											var newCheckinDate = new Date(date.getTime());
											newCheckinDate.setDate(date.getDate() + 1);
											var time = otaboFormatDate(otaboInput.checkin_time, false, 'time');
											newCheckinDate.setHours(parseInt(time.substring(0, 2)), parseInt(time.substring(3, 5)), 0, 0);
										
											checkinDateTableDate.setFullYear(newCheckinDate.getFullYear());
											checkinDateTableDate.setMonth(newCheckinDate.getMonth());
											checkinDateTableDate.setDate(1);
											checkinDateTableDate.setHours(0);
											checkinDateTableDate.setMinutes(0);
											checkinDateTableDate.setSeconds(0);

											otaboInput.checkin_time = otaboFormatDate(newCheckinDate, true);

											checkinDate.value = otaboFormatDate(otaboInput.checkin_time, false, 'date')
											loadMonth(document.getElementById(id + 'checkin_date_title'), document.getElementById(id + 'checkin_date_left'),
													document.getElementById(id + 'checkin_date_right'), checkinDateTable, checkinDateTableDate);
										}

										if (e)
										{
											checkoutDate.blur();
											checkoutDateCalendar.style.display = 'none';
										}
									}
									else
									{
										var time = otaboInput.checkin_time ? otaboFormatDate(otaboInput.checkin_time, false, 'time') : '00:00';
										date.setHours(parseInt(time.substring(0, 2)), parseInt(time.substring(3, 5)), 0, 0);

										otaboInput.checkin_time = otaboFormatDate(date, true);

										checkinDate.value = otaboFormatDate(date, false, 'date');

										if (defaultCheckoutTime && otaboInput.checkin_time.substr(0, 10) == otaboInput.checkout_time.substr(0, 10)
												&& otaboInput.checkin_time <= otaboInput.checkout_time)
										{
											date.setDate(date.getDate() + 1);
											otaboInput.checkin_time = otaboFormatDate(date, true);
										}
																				
										if (e)
										{
											checkinDate.blur();
											checkinDateCalendar.style.display = 'none';
										}
									}
								}
							}(title, left, right, table, shownDate, new Date(date));
						}
						else
						{
							td.classList.add('disabled');
							td.onmousedown = function(e)
							{
								if (e)
								{
									e.preventDefault();
									e.stopPropagation();
								}
							}
						}
					}

					date.setDate(date.getDate() + 1);
				}

				// Empty cells at the end.
				day = tr.children.length;
				for (; day < 7; day++)
				{
					var td = document.createElement('td');
					tr.appendChild(td);
					td.classList.add('none');
					td.onmousedown = function(e)
					{
						e.preventDefault();
						e.stopPropagating();
					}
				}
			};
			
			checkHours();

			loadMonth(document.getElementById(id + 'checkin_date_title'), document.getElementById(id + 'checkin_date_left'),
					document.getElementById(id + 'checkin_date_right'), checkinDateTable, checkinDateTableDate);
					
			///
			///
			// SUBMIT BUTTON
			///
			///
			document.getElementById(id + 'check_dates').onclick = function()
			{
				var error = false;
				if (!otaboInput.checkout_base)
				{
					error = true;
					checkoutBaseInput.parentNode.classList.add('error');
					
					alert(_S.booking_error_checkout_base);
				}
				
				if (document.getElementById(id + 'checkin_base_select_tick').checked && !otaboInput.checkin_base)
				{
					error = true;
					checkinBaseInput.parentNode.classList.add('error');

					alert(_S.booking_error_checkin_base);
				}

				
				if (!error && checkHours())
				{
					window.location = OTABO_RESULTS_URL
							+ (OTABO_RESULTS_URL.indexOf('?osd=') == -1 ? '?osd=' + osd : '')
							+ (otaboInput.clazz ? '&oc=' + encodeURI(otaboInput.clazz) : '')
							+ '&ob=' + encodeURI(otaboInput.checkout_base.index)
							+ '&ib=' + encodeURI(document.getElementById(id + 'checkin_base_select').checked && otaboInput.checkin_base ? otaboInput.checkin_base.index : '')
							+ '&ot=' + encodeURI(otaboInput.checkout_time)
							+ '&it=' + encodeURI(otaboInput.checkin_time)
							+ '&obs=' + encodeURI(otaboInput.checkout_base.name)
							+ '&ibs=' + encodeURI(document.getElementById(id + 'checkin_base_select').checked && otaboInput.checkin_base ? otaboInput.checkin_base.name : '')
							+ (youngDriver && youngDriver.checked ? '&yd=1' : '');
				}
				else if (!error)
				{
					alert(checkoutDateError.textContent != '' ? checkoutDateError.textContent : checkinDateError.textContent);
				}
			};
			
			checkoutBaseInput.placeholder = _S.label_select;
			checkinBaseInput.placeholder = _S.label_select;
			checkoutDate.placeholder = _S.label_select;
			checkoutTimeInput.placeholder = _S.label_select;
			checkinDate.placeholder = _S.label_select;
			checkinTimeInput.placeholder = _S.label_select;
			document.getElementById(id + 'form').disabled = false;
		}
		else
		{
			document.getElementById(id + 'error').style.display = 'block';
			document.getElementById(id + 'error_msg').innerHTML = response && response.error ? response.error : response;
		}
	});
}

function otaboLoadResults(osd, ob, ib, ot, it, oc, yd)
{
	var loading = document.getElementById('otabo_loading');
	loading.style.display = 'block';
	
	var params = ob ? ['cmd', 'results', 'osd', osd, 'ob', ob, 'ib', ib, 'ot', ot, 'it', it, 'oc', oc, 'yd', yd	] : ['cmd', 'results', 'osd', osd];
	otaboRequest(params, function(success, response)
	{
		if (success && response)
		{
			if (document.getElementById('otabo_checkout_base').innerHTML == '')
			{
				document.getElementById('otabo_checkout_base').innerHTML = response.result.input.checkout_base.name;
				document.getElementById('otabo_checkin_base').innerHTML = response.result.input.checkin_base.name;
				document.getElementById('otabo_checkout_time').innerHTML = otaboFormatDate(response.result.input.checkout_time);
				document.getElementById('otabo_checkin_time').innerHTML = otaboFormatDate(response.result.input.checkin_time);
			}
			
			// Print the groups.
			if (OTABO_PARAMS.result_groups && response.result.groups.length > 1)
			{
				var groupsDiv = document.getElementById('otabo_results_groups');
				var groupsUl = document.createElement('ul');
				groupsDiv.appendChild(groupsUl);

				var selectedGroups = [];
			
				for (var i in response.result.groups)
				{
					var group = response.result.groups[i];
					var li = document.createElement('li');
					li.style.backgroundImage = 'url(\'' + group.image + '\')';
				
					var span = document.createElement('span');
					span.className = 'name';
					span.innerHTML = group.name;
					li.appendChild(span);
				
					var span = document.createElement('span');
					span.className = 'rate';
					span.innerHTML = _S.results_group_rate.replace('{rate}', otaboFormatCurrency(group.min));
					li.appendChild(span);
				
					groupsUl.appendChild(li);
				
					li.onclick = function(group)
					{
						return function()
						{
							if (selectedGroups.indexOf(group.name) != -1)
							{
								selectedGroups.splice(selectedGroups.indexOf(group.name), 1);
								this.classList.remove('selected');
							}
							else
							{
								selectedGroups.push(group.name);
								this.classList.add('selected');
							}
						
							var results = [];
							for (var ii in response.result.quotes)
							{
								var quote = response.result.quotes[ii];
								if (selectedGroups.length == 0 || selectedGroups.indexOf(quote.group) != -1)
								{
									results.push(quote);
								}
							}
						
							results.sort(function(lhs, rhs)
							{
								var res = lhs.rate - rhs.rate;
								if (res == 0)
								{
									res = lhs.group.toLowerCase().localeCompare(rhs.group.toLowerCase());
								}
							
								if (res == 0)
								{
									res = lhs.name.toLowerCase().localeCompare(rhs.name.toLowerCase());
								}
							});

							printResults(results);
						}
					}(group);
				}
			
				var leftScroller = document.createElement('span');
				leftScroller.id = 'otabo_results_groups_lscroller';
				groupsDiv.appendChild(leftScroller);
				leftScroller.onclick = function()
				{
					for (var i = groupsUl.children.length - 1; i >= 0; i--)
					{
						if (groupsUl.children[i].offsetLeft - 5 < groupsUl.scrollLeft + 5)
						{
							groupsUl.scrollLeft = Math.min(groupsUl.scrollWidth - groupsUl.offsetWidth, groupsUl.children[i].offsetLeft - 10);
							break;
						}
					}
				};
			
				var rightScroller = document.createElement('span');
				rightScroller.id = 'otabo_results_groups_rscroller';
				groupsDiv.appendChild(rightScroller);
				rightScroller.onclick = function()
				{
					for (var i = 0; i < groupsUl.children.length; i++)
					{
						if (groupsUl.children[i].offsetLeft - 5 > groupsUl.scrollLeft + 5)
						{
							groupsUl.scrollLeft = Math.min(groupsUl.scrollWidth - groupsUl.offsetWidth, groupsUl.children[i].offsetLeft - 10);
							break;
						}
					}
				};
						
				groupsUl.onscroll = function()
				{
					leftScroller.style.display = groupsUl.scrollLeft > 0 ? 'block' : 'none';
					rightScroller.style.display = groupsUl.scrollLeft < groupsUl.scrollWidth - groupsUl.offsetWidth ? 'block' : 'none';
				}

				leftScroller.style.display = groupsUl.scrollLeft > 0 ? 'block' : 'none';
				rightScroller.style.display = groupsUl.scrollLeft < groupsUl.scrollWidth - groupsUl.offsetWidth ? 'block' : 'none';
			}
			
			// Print the results table.
			var resultsDiv = document.getElementById('otabo_results');
			resultsDiv.className = OTABO_PARAMS.result_full_width ? 'full-width' : '';

			var resultsUl = document.createElement('ul');
			resultsDiv.appendChild(resultsUl);
			
			var printResults = function(results)
			{
				while (resultsUl.children.length > 0)
				{
					resultsUl.removeChild(resultsUl.children[0]);
				}
				
				for (var i in results)
				{
					var quote = results[i];
					var li = document.createElement('li');
					resultsUl.appendChild(li);
				
					var h1 = document.createElement('h1');
					h1.innerHTML = quote.group;
					li.appendChild(h1);

					if (quote.name && quote.name != quote.group
							|| quote.tariff && quote.tariff.length > 0)
					{
						var h2 = document.createElement('h2');
						
						if (quote.name && quote.name != quote.group)
						{
							h2.innerHTML = quote.name;
						}
						
						if (!OTABO_PARAMS.result_full_width && quote.tariff && quote.tariff.length > 0)
						{
							h2.innerHTML += (h2.innerHTML == '' ? '' : ' - ' + quote.tariff);
						}
						
						li.appendChild(h2);
					}
				
					if (quote.vendor)
					{
						var ss = document.createElement('span');
						ss.className = 'company';
						ss.innerHTML = quote.vendor.name;
						ss.style.backgroundImage = 'url(\'' + quote.vendor.logo + '\')';
						li.appendChild(ss);
					}

					var box = document.createElement('div');
					li.appendChild(box);
					box.className = 'box';
						
					var info = document.createElement('div');
					box.appendChild(info);
					info.className = 'info';
								
					var img = document.createElement('img');
					img.style.backgroundImage = 'url(\'' + quote.image + '\')';
					info.appendChild(img);
					
					var table = document.createElement('table');
					info.appendChild(table);
					
					var tr = document.createElement('tr');
					table.appendChild(tr);
					
					var td = document.createElement('td');
					td.className = 'params';
					tr.appendChild(td);
				
					var div = document.createElement('div');
					td.appendChild(div);

					if (quote.params.VehicleFilters)
					{				
						var keys = ['Seats', 'Doors', 'SmallBags', 'BigBags', 'SeatsNo', 'CabinsNo', 'BerthsNo', 'ToiletsNo', 'Type'];
						for (var k in keys)
						{
							var key = keys[k];
							if (quote.params.VehicleFilters[key])
							{
								var p1 = null;
								var p2 = null;
								var s = '';
						
								var is = Object.keys(quote.params.VehicleFilters[key]).sort();
								for (var i in is)
								{
									i = is[i];
									if (quote.params.VehicleFilters[key][i])
									{
										if (p1 == null)
										{
											s += (s == '' ? '' : ', ') + i.substr(1);
											p1 = i.substr(1);
											p2 = p1;
										}
										else if (p2 == parseInt(i.substr(1)) - 1)
										{
											p2 = i.substr(1);
										}
										else
										{
											if (p2 != p1)
											{
												s += '-' + p2;
											}
									
											s += (s == '' ? '' : ', ') + i.substr(1);

											p1 = i.substr(1);
											p2 = p1;											
										}
									}
								}
						
								if (p2 != p1)
								{
									s += '-' + p2;
								}
					
								if (s != '')
								{
									if (key == 'CabinsNo' && quote.params.VehicleFilters['CabinSkipper'] && quote.params.VehicleFilters['CabinSkipper'].V1
											&& quote.params.VehicleFilters['CabinSkipper'].V1 != false)
									{
										s += '+1';
									}
									
									var ss = document.createElement('span');
									ss.className = key.toLowerCase();
									ss.innerHTML = s + (_S['param_VehicleFilters_' + key] ? ' ' + _S['param_VehicleFilters_' + key] : '');
									ss.style.backgroundImage = 'url(\'' + OTABO_IMG_DIR + 'icon_param_' + key.toLowerCase() + '.png' + '\')';
									div.appendChild(ss);
								}
							}
						}
				
						if (quote.params.VehicleFilters.Gearshift)
						{
							var s = '';
							for (var i in quote.params.VehicleFilters.Gearshift)
							{
								s += (s == '' ? '' : ', ') + _S['param_VehicleFilters_Gearshift_' + i];
							}

							if (s != '')
							{
								var ss = document.createElement('span');
								ss.className = 'gearshift';
								ss.innerHTML = s;
								ss.style.backgroundImage = 'url(\'' + OTABO_IMG_DIR + 'icon_param_gearshift.png' + '\')';
								div.appendChild(ss);
							}
						}

						if (quote.params.VehicleFilters.FuelType)
						{
							var s = '';
							for (var i in quote.params.VehicleFilters.FuelType)
							{
								s += (s == '' ? '' : ', ') + _S['param_VehicleFilters_FuelType_' + i];
							}
					
							if (s != '')
							{
								var ss = document.createElement('span');
								ss.className = 'fueltype';
								ss.innerHTML = s;
								ss.style.backgroundImage = 'url(\'' + OTABO_IMG_DIR + 'icon_param_fueltype.png' + '\')';
								div.appendChild(ss);
							}
						}
					}
					
					// Print the km limit only if it's the same for all options.
					if (quote.hasOwnProperty('km_limit'))
					{
						var limit = quote.km_limit;
						var noLimit = false;
					
						if (OTABO_PARAMS.result_full_width)
						{
							for (var i in quote.options)
							{
								if (quote.options[i].km_limit != limit)
								{
									noLimit = true;
									break;
								}
							}
						}
				
						if (!noLimit && quote.km_limit && quote.km_limit.length > 0 && quote.km_limit_period && quote.km_limit_period.length > 0)
						{
							var ss = document.createElement('span');
							ss.className = 'kmlimit';
							ss.innerHTML = quote.km_limit + ' km/' +  quote.km_limit_period;
							ss.style.backgroundImage = 'url(\'' + OTABO_IMG_DIR + 'icon_param_kmlimit.png' + '\')';
							div.appendChild(ss);
						}
						else if (!noLimit)
						{
							var ss = document.createElement('span');
							ss.className = 'kmlimit';
							ss.innerHTML = _S.param_VehicleFilters_KmLimit_None;
							ss.style.backgroundImage = 'url(\'' + OTABO_IMG_DIR + 'icon_param_kmlimit.png' + '\')';
							div.appendChild(ss);
						}
					}
				
					if (div.children.length == 0)
					{
						div.innerHTML = '&nbsp;';
					}
				
					if (!OTABO_PARAMS.result_full_width)
					{
						var td = document.createElement('td');
						td.className = 'rate';
						tr.appendChild(td);
					
						var div = document.createElement('div');
						td.appendChild(div);
				
						var span = document.createElement('span');
						span.innerHTML = _S.results_rate;
						div.appendChild(span);
				
						var span = document.createElement('span');
						span.innerHTML = otaboFormatCurrency(quote.rate);
						div.appendChild(span);
					
						var a = document.createElement('a');
						if (quote.coverages && quote.coverages.length > 0)
						{
							a.href = OTABO_BOOKING_COVERAGES_URL + '&qid=' + quote.id;
						}
						else if (quote.optionals && quote.optionals.length > 0)
						{
							a.href = OTABO_BOOKING_OPTIONALS_URL + '&qid=' + quote.id;
						}
						else
						{
							a.href = OTABO_BOOKING_URL + '&qid=' + quote.id;
						}
					
						var button = document.createElement('button');
						button.innerHTML = _S.results_select;
						a.appendChild(button);
					
						div.appendChild(a);
						
						// Any required optionals?
						var optionals = '';
						for (var i in quote.optionals)
						{
							if (quote.optionals[i].required && quote.optionals[i].required == true && quote.optionals[i].rate > 0)
							{
								optionals += (optionals == '' ? '' : '<br />') + _S['results_optionals']
										.replace('{name}', quote.optionals[i].name)
										.replace('{price}', otaboFormatCurrency(quote.optionals[i].rate));
							}
						}
						
						if (optionals != '')
						{
							var span = document.createElement('span');
							info.appendChild(span);
							span.className = 'hint';
							span.innerHTML = optionals;
						}
					}

					// Any other details?
					var detailsBox = null;
					if (OTABO_PARAMS.result_details && OTABO_PARAMS.result_details.length > 0 && quote.params
							|| OTABO_PARAMS.result_full_width)
					{
						detailsBox = document.createElement('div');
						detailsBox.className = 'details';
						
						var div = document.createElement('div');
						div.className = 'params';
												
						for (var j in OTABO_PARAMS.result_details)
						{
							var details = null;
							var id = OTABO_PARAMS.result_details[j];

							for (var jj in OTABO_RESULT_DETAILS)
							{
								if (OTABO_RESULT_DETAILS[jj].id == id)
								{
									details = OTABO_RESULT_DETAILS[jj].values;
								}
							}
							
							if (details && quote.params[id])
							{
								var uul = document.createElement('ul');
								uul.className = 'param_' + id;
								
								for (var jj in details)
								{
									if (quote.params[id][details[jj]]
											&& quote.params[id][details[jj]].length > 0)
									{
										var lli = document.createElement('li');
										uul.appendChild(lli);
										
										if (_S['param_' + id + '_' + details[jj]]
												&& _S['param_' + id + '_' + details[jj]].length > 0)
										{
											var span = document.createElement('span');
											lli.appendChild(span);
											span.innerHTML = _S['param_' + id + '_' + details[jj]] + ':';
										}
										
										var value = _S['param_' + id + '_' + details[jj] + '_' + quote.params[id][details[jj]]];
										var span = document.createElement('span');
										lli.appendChild(span);
										span.innerHTML = value === undefined ? quote.params[id][details[jj]] + (_S['param_' + id + '_' + details[jj] + '_Unit'] ? _S['param_' + id + '_' + details[jj] + '_Unit'] : '') : value;
									}
								}
								
								if (uul.children.length > 0)
								{
									var innerDiv = document.createElement('div');
									var hh = document.createElement('h3');
									hh.innerHTML = _S['param_' + id];
									innerDiv.appendChild(hh);									
									innerDiv.appendChild(uul);
									div.appendChild(innerDiv);
								}
							}
						}
						
						if (div.children.length > 0)
						{
							detailsBox.appendChild(div);
							box.appendChild(detailsBox);
							
							if (!OTABO_PARAMS.result_full_width)
							{
								var topScroller = document.createElement('span');
								topScroller.className = 'otabo_result_details_tscroller';
								detailsBox.appendChild(topScroller);
								topScroller.onclick = ((div, topScroller, bottomScroller) =>
								{
									return function()
									{
										div.scrollTop = Math.max(0, div.scrollTop - 50);
									}
								})(div, topScroller, bottomScroller);

			
								var bottomScroller = document.createElement('span');
								bottomScroller.className = 'otabo_result_details_bscroller';
								detailsBox.appendChild(bottomScroller);
								bottomScroller.onclick = ((div, topScroller, bottomScroller) =>
								{
									return function()
									{
										div.scrollTop = Math.min(div.scrollHeight - div.offsetHeight, div.scrollTop + 50);
									}
								})(div, topScroller, bottomScroller);
						
								div.onscroll = ((div, topScroller, bottomScroller) =>
								{
									return function()
									{
										topScroller.style.display = div.scrollTop > 0 ? 'block' : 'none';
										bottomScroller.style.display = div.scrollTop < div.scrollHeight - div.offsetHeight ? 'block' : 'none';
									}
								})(div, topScroller, bottomScroller);

								topScroller.style.display = div.scrollTop > 0 ? 'block' : 'none';
								bottomScroller.style.display = div.scrollTop < div.scrollHeight - div.offsetHeight ? 'block' : 'none';
							}
							
							var button = document.createElement('button');
							li.appendChild(button);
							button.className = 'details_toggle';
							button.innerHTML = _S['results_details'];
							button.onclick = ((button, detailsBox) =>
							{
								return function()
								{
									if (!detailsBox.classList.contains('shown'))
									{
										detailsBox.classList.add('shown');
										button.innerHTML = _S['results_details_back'];
									}
									else
									{
										detailsBox.classList.remove('shown');
										button.innerHTML = _S['results_details'];
									}
								}
							})(button, detailsBox);
						}
						else if (OTABO_PARAMS.result_full_width)
						{
							box.appendChild(detailsBox);
						}
					}
					
					if (OTABO_PARAMS.result_full_width)
					{
						var div = document.createElement('div');
						detailsBox.appendChild(div);
						div.className = 'options';
						
						var days = Math.ceil((new Date(response.result.input.checkin_time.replace(' ', 'T') + '+00:00')
								- new Date(response.result.input.checkout_time.replace(' ', 'T') + '+00:00')) / (24.0 * 60 * 60 * 1000));
						
						var ul = document.createElement('ul');
						div.appendChild(ul);
						
						var li = document.createElement('li');
						ul.appendChild(li);
						li.className = 'days';
						li.innerHTML = days == 1 ? _S['results_options_day'] : _S['results_options_days'].replace('{days}', days);
						
						var options = [quote];
						if (quote.options)
						{
							for (var i in quote.options)
							{
								options.push(quote.options[i]);
							}
						}
						
						for (var i in options)
						{
							var li = document.createElement('li');
							ul.appendChild(li);
							
							var a = document.createElement('a');
							li.appendChild(a);
							
							if (quote.coverages && quote.coverages.length > 0)
							{
								a.href = OTABO_BOOKING_COVERAGES_URL + '&qid=' + quote.id + (i == 0 ? '' : '.' + (i - 1));
							}
							else if (quote.optionals && quote.optionals.length > 0)
							{
								a.href = OTABO_BOOKING_OPTIONALS_URL + '&qid=' + quote.id + (i == 0 ? '' : '.' + (i - 1));
							}
							else
							{
								a.href = OTABO_BOOKING_URL + '&qid=' + quote.id + (i == 0 ? '' : '.' + (i - 1));
							}
							
							if (options[i].tariff)
							{
								var span = document.createElement('span');
								a.appendChild(span);
								span.className = 'tariff';
								span.innerHTML = options[i].tariff;
							}
							
							var span = document.createElement('span');
							a.appendChild(span);
							span.className = 'rate';
							span.innerHTML = otaboFormatCurrency(options[i].rate);
						}
												
						// Any required optionals?
						var optionals = '';
						for (var i in quote.optionals)
						{
							if (quote.optionals[i].required && quote.optionals[i].required == true && quote.optionals[i].rate > 0)
							{
								optionals += (optionals == '' ? '' : '<br />') + _S['results_optionals']
										.replace('{name}', quote.optionals[i].name)
										.replace('{price}', otaboFormatCurrency(quote.optionals[i].rate));
							}
						}
						
						var hint = _S['results_options_hint'];
						if (optionals != '')
						{						
							hint += (hint == '' ? '' : '<br /><br />') + optionals;
						}
						
						var li = document.createElement('li');
						ul.appendChild(li);
						li.innerHTML = hint;
					}
				}
			}
			
			if (response.result.quotes.length > 0)
			{
				printResults(response.result.quotes);
			}
			else
			{
				document.getElementById('otabo_error').style.display = 'block';
				document.getElementById('otabo_error_msg').innerHTML = _S['results_none'];
			}
		}
		else
		{
			document.getElementById('otabo_error').style.display = 'block';
			document.getElementById('otabo_error_msg').innerHTML = response && response.error ? response.error : response;
		}

		loading.style.display = 'none';
	});
}
